'FFSubmenu=Rahmen
'FFName=MFDL-Toolbox

'(c) Harald Maeckler, Dsseldorf 2008 - 2016

' ********************************************************************
' MFDL_Toolbox.vbs (Script fr FixFoto)
' Funktion:	MFDL-Rahmen auflisten und
'			- Anlagemglichkeit von virtuellen Listen (ab Version 5.00)
'			- Rahmen in den Listen durchzutakten mit Anzeige einer Vorschau
'			- Umwandlung von Absolutwerten in Promillewerte und umgekehrt - auf Wunsch speichern
'			- Prozentuale Skalierung - auf Wunsch speichern
'			- Rahmen lschen, umbenennen, sortieren und verschieben
'			- Rahmung mit ausgewhltem Rahmen durchfhren
'
' Version 5.11 vom 29.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 5.10 vom 15.06.2015	- auch bei 'Beschnitt' werden jetzt alle im Computerverzeichnis markierten
'									Bilder nacheinander bearbeitet, wenn sich kein Bild auf der Arbeitsflche befindet
'								- Bereinigung von Meldungen und Abfragen rund um 'Beschnitt'
'								- berarbeitung der Kurzbeschreibung
' Version 5.04 vom 09.06.2015	- Fehler bei Neuanlage eines Beschnittwertes beseitigt
'								- Update-Funktion aktualisiert
' Version 5.03 vom 25.10.2012	- Backup wird nicht mehr bei jedem Start angelegt
'									sondern nur noch auf den Befehl 'Backup' hin
' Version 5.02 vom 21.09.2012	- Duplikatstest aller Rahmen (Aufruf mit Taste y, bzw. Alt + y)
' Version 5.01 vom 15.09.2012	- Rahmeninfo erweitert um die Info ob das Bild durch den Rahmen vergrert wird
'								- Duplikatstest des ausgewhlten Rahmens (Aufruf mit Taste x, bzw. Alt + x)
'								- Kurzbeschreibung angepasst
' Version 5.00 vom 14.09.2012	- Listenmanagement mit allen Konsequenzen fr das Rahmenhandling
'								- Kurzbeschreibung angepasst
' Version 4.01 vom 01.09.2012	- Sicherheitsabfrage beim Sortieren
'								- Lupenfunktion bleibt auch bei Rahmenauswahl durch Doppelklick erhalten
' Version 4.00 vom 31.08.2012	- Komplette berarbeitung zur Beschleunigung einiger Funktionen
'								- Sortierung bercksichtigt Umlaute und Gro-/Kleinschreibung
'								- Lupenfunktion bleibt beim Durchtakten von Rahmen eingeschaltet 
'								- einige Button umbenannt und teilweise anders angeordnet
'								- Updatefunktion hinzugefgt
'								- Toltips hinzugefgt
'								- ausfhrliche Kurzbeschreibung als PDF
' Version 3.06 vom 25.11.2010	- Markierung im Dialog Ausschneiden angepasst an FF 3.02.25
' Version 3.05 vom 01.09.2009	- Automatisierung "Kopieren/Einfgen", sofern in der Rahmenart 'Text einblenden' 
'								  genau der Text "vorher Bild kopieren; danach einfgen" eingetragen ist
' Version 3.04 vom 08.07.2009	- Lschroutine hinzugefgt und KB entsprechend ergnzt
' Version 3.03 vom 25.03.2009	- Fortschrittsanzeige korrigiert (inzw. entfallen)
' Version 3.02 vom 24.03.2009	- Vorschau nach Skalierung gendert
'								- Registry erweitert um Speicherparameter (SP) und Toolbox (TB)
' Version 3.01 vom 20.03.2009	- Skalierung getrennt fr Strke und Position mglich
' Version 3.00 vom 16.02.2009	- Direkter Beschnitt mglich, um nach der Rahmung ein bestimmtes Seitenverhltnis zu erhalten
' Version 2.14 vom 12.02.2009	- Vergrerungsinfo hinzugefgt
' Version 2.13 vom 07.01.2009	- Bug in 'Speichern' wenn Rahmenname beibehalten wird, beseitigt
' Version 2.12 vom 07.01.2009	- auch 'zum Anfang','auf','ab' und 'zum Ende' jetzt steuerbar ber Tastatur
'								  und weitere Befehle
' Version 2.11 vom 05.01.2009	- die meisten Befehle knnen jetzt auch mit Alt + unterstrichenem Zeichen
'								  ausgelst werden
' Version 2.10 vom 03.01.2009	- Speichern weiter beschleunigt
'								- Vorschauschrfung
'								- Skript aufgerumt
' Version 2.09 vom 02.01.2009	- Speichern nach Sortieren und Verschieben beschleunigt
' Version 2.08 vom 01.01.2009	- Editoraufruf hinzugefgt
' Version 2.07 vom 29.12.2008	- Protokoll erweitert um Meldung 'Absolut- bzw. Promillewerte vorhanden'
' Version 2.06 vom 25.12.2008	- Bug in 'Rahmen speichern' und 
'								  Bug in Aktivierung der Umwandlung beseitigt 
' Version 2.05 vom 23.12.2008	- Protokollierung angepasst 
' Version 2.04 vom 23.12.2008	- Umwandlung und Skalierung wird beibehalten bis 'Reset' oder neuem Rahmen
' Version 2.03 vom 22.12.2008	- Fortschrittsanzeige bei 'Verschieben Aus' und 'Sortieren' (inzw. entfallen)
' Version 2.02 vom 22.12.2008	- Fehler in Umwandlung Absolutwerte beseitigt
' Version 2.01 vom 21.12.2008	- Fehler in Umwandlung Promillewerte beseitigt
' Version 2.00 vom 20.12.2008	- Umbenennung in MFDL-Toolbox
' Version 1.10 vom 18.12.2008	- Kurzbeschreibung ergnzt
' Version 1.09 vom 17.12.2008	- kleine Bugs beseitigt und Lupenfunktion eingefgt
' Version 1.08 vom 16.12.2008	- beim Speichern Doppel ersetzen
' Version 1.07 vom 14.12.2008	- Rahmen sortieren
' Version 1.06 vom 13.12.2008	- Rahmen verschieben
' Version 1.05 vom 10.12.2008	- Rahmen lschen und umbenennen
' Version 1.04 vom 04.12.2008	- Durchblttern der Rahmenliste mit schneller Vorschau
' Version 1.03 vom 28.11.2008	- kein Bild in der Arbeitsflche -> selektierte Bilder bearbeiten
' Version 1.02 vom 27.11.2008	- bei 'Text einblenden' werden fr Skalierung und
'								  Umwandlung in Promillewerte nur Positionswerte bercksichtigt
' Version 1.01 vom 26.11.2008	- Skalierung hinzugefgt
' Version 1.00 vom 24.11.2008	- erste Versuche mit Umwandlung in Promillewerte
'  
'** Start Kurzbeschreibung *******************************************
' MFDL_Toolbox / Version 5.11
' ==================
' Das Skript dient vorrangig dazu, vorhandene MFDL-Rahmen ber eine Vorschau aus-
' zuwhlen und damit ein Bild oder auch mehrere zu rahmen.
' Auerdem knnen bei vorhandenen MFDL-Rahmen Strkewerte und Positionswerte in
' Promillewerte oder Absolutwerte umzuwandeln. Auerdem knnen die Strkewerte
' und Positionswerte skaliert werden. Die genderten Werte lassen sich als neue 
' Rahmen abspeichern.
' Mit einfachem Mausklick auf das Vorschaubild kann jederzeit der momentane Zustand des
' Rahmentexts mit den bisher vorgenommenen Bearbeitungsschritten zur Anzeige gebracht
' werden.
' Weiterhin knnen Rahmen gelscht, umbenannt, sortiert, verschoben und editiert werden.
' Auch die Berechnung eines Beschnitts um ein gewnschtes Seitenverhltnis nach der
' Rahmung zu erreichen, kann vorgenommen und auch direkt ausgefhrt werden.
'
' Ist bei einer Befehlstaste ein Zeichen unterstrichen, kann man den Befehl nicht nur
' mit einem Klick der linken Maustaste sondern auch mit der Tastenkombination
' 'Alt + unterstrichenem Zeichen' oder nur durch Tastenbettigung auslsen.
'
' Listen
' -------
' Zur besseren Organisation der Rahmen knnen virtuelle Listen angelegt werden.
' Es existiert immer die reale Liste 'Standard', die alle Rahmen der Rahmendatei MFDL.cfg
' im FF-Datenordner enthlt. Wurden zustzliche virtuelle Listen angelegt, kann jeweils
' eine Liste ausgewhlt und die darin enthaltenen Rahmen angezeigt werden.
'
' - Neu
' Man wird aufgefordert den Namen einer neuen Liste anzugeben. Diese wird nach 'OK' ange-
' legt und gleichzeitig der Modus 'Rahmen hinzufgen' aktiviert.
' 
' - Umbenennen
' Der ausgewhlten virtuellen Liste kann ein anderer Name gegeben werden.
'
' - Lschen
' Die ausgewhlte virtuelle Liste wird gelscht.
'
' - Rahmen hinzufgen
' Mit dem ersten Mausklick wird der Modus eingeschaltet und mit dem zweiten wieder aus-
' geschaltet. Bei der Aktivierung wird automatisch auf die Anzeige der Liste 'Standard'
' umgeschaltet und gleichzeitig angezeigt, dass jetzt Rahmen kopiert werden knnen aus
' der Liste 'Standard' in die vorher ausgewhlte virtuelle Liste.
' Das Hinzufgen des markierten Rahmens erfolgt durch Bettigung von 'Hinzu' oder durch
' doppelten Mausklick auf einen bereits in der Vorschau gezeigten Rahmen.
' Wird der Modus wieder ausgeschaltet, wird zurckgeschaltet auf die virtuelle Liste mit
' den hinzugefgten Rahmen.
' 
' Vorschau mit Lupenfunktion
' ---------------------------------
' Es wird immer eine Vorschau des aktuellen Bildes, gerahmt mit dem aktiven Rahmen in
' der Rahmenliste, angezeigt. Aktuell ist das Bild, das auf der Arbeitsflche von FixFoto
' gerade angezeigt wird oder, wenn nicht vorhanden, das erste der im Computerverzeichnis
' markierten Bilder.
' In der Rahmenliste aktiviert man einen Rahmen ber die Befehlsschaltflchen 'zum Anfang',
' 'Auf', 'Ab' oder 'zum Ende' bzw. durch Bettigung der Tasten 1, 2, 3, oder4. Man kann
' damit die Rahmenliste durchblttern und dabei die Wirkung der Rahmen beim aktiven Bild
' als Vorschaubild begutachten
' Whlt man einen Rahmen durch Anklicken mit der linken Maustaste oder ber die Cursor-
' tasten des Computers, kann der gewhlte Rahmen durch Anklicken des Befehls 'Vorschau'
' oder mit einem Doppelklick der linken Maustaste auf den ausgewhlten Rahmen aktiviert
' werden. 
' Der Name des aktivierten Rahmens wird unter dem Vorschaubild angezeigt.
'
' Die Lupenbefehle erlauben, sich das linke obere oder wahlweise das rechte untere Viertel
' des Vorschaubildes anzeigen zu lassen.
'
' Umwandlung
' ---------------
' Hier stehen die Befehle Umwandlung 'in Promillewerte' und 'in Absolutwerte' zur Verfgung.
' Die Umwandlung bezieht sich immer auf den zur Vorschau benutzten Rahmen und basiert auf
' der Auflsung des angezeigten Bildes. Bei der Rahmenart 'Text einblenden' werden nur die 
' Positionswerte bercksichtigt.
' Eine mehrfache Umwandlung zwischen Promille- und Absolutwerte sollte wegen unvermeid-
' barer Rundungsfehler vermieden werden.
' Die Umwandlung bleibt erhalten bis 'Reset' bettigt oder ein neuer Rahmen zur Vorschau
' ausgewhlt wird.
' Der genderte Zustand kann mit 'Speichern' gesichert werden.
' 
' Skalierung
' -------------
' Die Mawerte des zur Vorschau benutzten Rahmens werden bei 'Ausfhren' mit dem einge-
' gebenen Skalierwert multipliziert. Standardmig erfolgt dies fr die Strke- und Posi-
' tionswerte. Es kann aber gewhlt werden, dass die Skalierung nur fr die Strken oder 
' nur die Positionen eines Rahmens erfolgen soll.
' Bei der Rahmenart 'Text einblenden' werden immer nur die Positionswerte bercksichtigt.
'
' Die Wirkung der Skalierung wird sofort nach 'Ausfhren' in der Vorschau angezeigt. Mehr-
' maliges Skalieren ist erlaubt und ermglicht das Herantasten an den optimalen Wert.
'
' Die Skalierung bleibt erhalten bis 'Reset' bettigt oder ein neuer Rahmen zur Vorschau
' ausgewhlt wird. Sie kann aber auch mit 'Speichern' gesichert werden.
'
' Speichern
' ------------
' Bei 'Speichern' wird nach der Benennung des genderten Rahmens gefragt. Der Rahmen wird
' immer in der realen Liste 'Standard' abgespeichert und ggf. in der aktiven virtuellen
' Liste. Nach dem Speichern wird der Rahmen am Ende der Liste unter seinem neuen Namen
' angezeigt.
'
' Editor
' -------
' Der Editor erlaubt die manuelle Modifizierung des aktuellen Rahmens. nderungen werden nach
' Speichern im Editor bernommen und direkt in der Vorschau angezeigt. 
' Eine Modifikation bleibt erhalten bis 'Reset' bettigt oder ein neuer Rahmen zur Vorschau
' ausgewhlt wird.

' +++ Vorsicht +++
' nderungen im Editor sollte man nur vornehmen, wenn man sich mit der Rahmenstruktur auskennt.
' Es wird zwar versucht, Modifikationen auf Zulssigkeit zu prfen, Fehler ggf. anzuzeigen und
' wenn Fehler vorhanden sind, den Ursprungszustand wieder herzustellen, aber es kann auch sein,
' dass im Fehlerfall das Skript abstrzt.
' Im FF-Forum kann man sich bei Interesse die Beschreibung MFDL-Rahmenstruktur herunter laden.
'
' Beschnitt
' -----------
' Es wird angezeigt, um wie viel Pixel sich das Bild durch die gewhlte Rahmung mglicherweise ver-
' grert und wie sich dadurch das Seitenverhltnis ndert. Auf Wunsch kann dann ein nach der Rahmung
' zu erzielendes Format gewhlt und der dazu erforderliche Beschnitt durchgefhrt werden. Beim Dialog
' 'Ausschneiden' kann der vorgegebene Ausschnitt beliebig verschoben und abhngig von verschiedenen
' Faktoren ggf. auch verkleinert werden. Der Nutzer wird vor dem Dialog entsprechend informiert.
'
' Wird beim Start des Beschnitts auf der Arbeitsflche von FixFoto kein Bild angezeigt, werden alle
' im Computerverzeichnis markierten Bilder nacheinander bearbeitet. Dabei wird zu Beginn abgefragt,
' welchen Suffix- oder Prfix-Text die Originalnamen erhalten sollen und mit welcher JPEG-Qualitt
' die Bilder gespeichert werden sollen. Dann wird zur Wahl des Beschnittformats aufgefordert.
' Fr jedes Bild wird anschlieend der Ausschneide-Dialog angezeigt, dort werden sie beschnitten,
' dann gerahmt und die gerahmten Bilder im gewnschten Format gespeichert.
'
' +++ Tipp +++
' Die proportionale Auswahl des Ausschnitts ist immer mglich, wenn die Rahmenwerte in Promille ange-
' geben sind.
'
' Sortieren
' ------------
' Alle Rahmen der aktiven Liste werden alphanumerisch sortiert.
'
' +++ Tipp +++
' Um bevorzugte Rahmen nach oben zu sortieren, kann man die Namen z.B. mit einer 3-stelligen Zahl
' beginnen lassen, also mit 000, 001, 002 usw.
'
' Umbenennen
' ----------------
' Fr den gewhlten Rahmen kann ein anderer Name eingegeben und bernommen werden. Die Umbenennung
' betrifft immer den Rahmen in der Liste 'Standard' und in allen virtuellen Listen, in denen er
' vorkommt.
' 
' Lschen
' ----------
' Ist die aktive Liste die Liste 'Standard', wird der gewhlte Rahmen wird nach einer Sicherheitsab-
' frage unwiderruflich gelscht und, falls vorhanden, aus allen virtuellen Listen gelscht.
' Ist eine virtuelle Liste aktiv, wird der Rahmen lediglich aus dieser Liste entfernt.
'
' Verschieben
' ---------------
' Wenn Verschieben aktiviert ist, kann mit den Befehlsschaltflchen '1 = Anf.', '2 = auf', '3 = ab'
' oder '4 = Ende' bzw. den Tasten '1', '2', '3' oder '4' der gerade markierte Rahmen verschoben werden.
' Whrenddessen ist 'Lschen', 'Umbenennen' und 'Sortieren' gesperrt.
' - Mit 'Abbruch' wird die ursprngliche Reihenfolge wieder hergestellt.
' - Mit Deaktivierung wird die gerade bestehende Reihenfolge abgespeichert.
'
' Suchen nach Duplikaten
' --------------------------
' Mit der Taste 'x' bzw. der Tastenkombination 'Alt' + 'x' wird ein Suchlauf nach Duplikaten zum
' markierten Rahmen unter anderen Namen gestartet. Werden Duplikate gefunden, werden diese angezeigt
' und gefragt, ob sie gelscht werden sollen. Bei Antwort 'Ja' werden sie unwiderrruflich gelscht
' und, falls vorhanden, aus allen virtuellen Listen gelscht.
' 
' Mit der Taste 'y' bzw. der Tastenkombination 'Alt' + 'y' wird ein Suchlauf nach Duplikaten aller
' Rahmen unter anderen Namen gestartet. Werden Duplikate gefunden, werden diese angezeigt
' und gefragt, ob sie gelscht werden sollen. Bei Antwort 'Ja' werden sie unwiderrruflich gelscht
' und, falls vorhanden, aus allen virtuellen Listen gelscht.
'
' Backup
' -------------
' Nach Rckfrage wird ein Backup der Rahmendatei 'MFDL.cfg' im FF-Datenverzeichnis unter dem Namen
' 'MFDL_Backup.cfg' angelegt.
'
' Rahmung
' -----------
' Mit 'Rahmung' wird die in der Vorschau gezeigte Rahmung durchgefhrt und das Skript beendet.
'
' Wird auf der Arbeitsflche von FixFoto kein Bild angezeigt, werden alle im Computerverzeichnis
' markierten Bilder nacheinander gerahmt und abgespeichert. Dabei wird zu Beginn abgefragt,
' welchen Suffix- oder Prfix-Text die Originalnamen erhalten sollen und mit welcher JPEG-
' Qualitt die fertigen Bilder abgespeichert werden sollen.
'
' +++ Tipp +++
' Werden mehrere Bilder mit verschiedenen Auflsungen gerahmt, wird empfohlen absolute Rahmenwerte
' in Promillewerte umzuwandeln. So bleiben die Rahmenproportionen auch bei verschiedenen Auflsungen
' erhalten.
'
' ### Anmerkung ###
' Ist in der Rahmenart 'Text einblenden' genau der Text "vorher Bild kopieren; danach einfgen"
' eingetragen, wird vom Skript automatisch das Originalbild in das gerahmte Bild mittig  kopiert.
' Das ist besonders praktisch, wenn mehrere Bilder in einem Durchgang gerahmt werden, weil dabei gar
' nicht die Mglichkeit besteht, die Originale in die Zwischenablage zu kopieren und dann wieder
' einzufgen.
'
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen angeboten,
' davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach werden nach-
' einander die Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle Zusatz-
' dateien gelscht. Abschlieend wird die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit 
' allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

const VerbZ = "/,\,:,*,?,<,>,|"								'in Dateinamen verbotene Zeichen
const Schaerfegrad = 25										'Schrfegrad fr die Vorschau

Dim OrigBreite,OrigHoehe,PopZaehler,SkriptKill,Antwort,TempFile
Dim RahmenDatei,RahmenDateiTmp,Breite,Hoehe,Referenz,Originalreferenz,Faktor,Rahmenart,msg,msg1
Dim Skalierwert,SkalierwertPo,SkalierwertSt,Anzahl,AnzB
Dim RahmenAuswahl,RahmenAktuell,RahmenAktiv,ProtokollKopf, Protokoll,RahmenErsetzen,AnzeigeZeile
Dim RahmenzeilenZahl,RahmenNeu,Liste,ListenArray,ListeMax,RahmenZeiletext,Rahmentest,SV_Wert

Dim flagSelektierteBilder,imagecount,Bild,OriginalBild,n,Pfad,File,Ext,VorschauRichtung
Dim quality,boolSuffix,Zusatz,Absolutwerte,Promillewerte,Rahm_Wert,flag_RahmungSB

const TAnzeige = false										'Zeitmessung
Dim TAnfang,TEnde

'Variable fr die Rahmenerzeugung
Dim	WertArray,STlinks,SToben,STrechts,STunten,POlinks,POoben,POrechts,POunten
Dim Farbe,RRahmFarbe,GRahmFarbe,BRahmFarbe,RVerlFarbe,GVerlFarbe,BVerlFarbe
Dim RegDeck,RegWeich,RegEffekt,TextFont,flag_Copy
Dim R_ungleich,Rgeloescht
Dim flag_Reset : flag_Reset = false

'Dimensionierungen fr Vorschau mit verkleinertem Bild
const boolVorschauVerkleinert = true	'kann zu Testzwecken auf false gesetzt werden
const MaxLaenge = 400
Dim LangeSeite,FaktorSV

'Beschnitt
const StdSeitenverhaeltnisse = "9:7/4:3/7:5/Din-QF/3:2/16:9/Gold.Schn.-QF/Original/1:1/7:9/3:4/5:7/Din-HF/2:3/9:16/Gold.Schn.-HF/"
const StdSeitenverhWerte     = "1,286/1,333/1,4/1,414/1,5/1,778/1,618/-/1/0,778/0,750/0,714/0,707/0,667/0,563/0,618/"
Dim Seitenverhaeltnisse,SeitenverhWerte,BzuH_Array,BzuH_Werte,SV_Zahl,Markierung
Dim SchnittTextSperre : SchnittTextSperre = false

const SkriptName = "MFDL_Toolbox.vbs"							'Skriptname
Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch			'Kurzbeschreibungen
const ForReading = 1, ForWriting = 2, ForAppending = 8
Dim BackUpDatei,flag_BackUp : flag_BackUp = false				'BackUp

'=============================== neu ab Version 4.00 ====================
Dim UrListenArray,NeuListenArray,Ergebnis,Max					'Sortierung
const BZ = "#"	 	'Block-Trennzeichen fr die Datenstze
const EZ = "\"		'Ersatz fr Zeilenwechsel 'vbNewLine'
const TZ = "@"		'Trennzeichen zur Kennzeichnung von Umlauten

Dim ZeitTest : ZeitTest = false									'true = Anzeige der Sortierzeit

Dim LupeLinksEin,LupeRechtsEin : LupeLinksEin = 0 : LupeRechtsEin = 0	'Lupe

const SkriptVersion = "5.11"									'Updatefunktion
const SkriptURL = "http://www.ffsf.de/resources/mfdl-toolbox.159/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

Dim flagRahmenHinzu,Listendatei									'Listen

Dim ListeAktuell,Rahmenfolge,RahmenSumme
'========================================================================

Dim objFS,WshShell												'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")
'------------------------------------------------------------------------
call Main
Set objFS = nothing
Set WshShell = nothing
'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm
Dim Anzeige,OK,Datei,Zeile,iText
flag_RahmungSB = false
flag_Copy = false

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	RahmenDatei = FF_GetScriptPath() & "\MFDL.cfg"
 	if Err.Number > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

BackUpDatei = FF_GetScriptPath() & "\MFDL_Backup.cfg"
Listendatei = FF_GetScriptPath & "\MeckiScript\MFDL_Toolbox\MFDL_Listen.ini"
RahmenDateiTmp = FF_GetScriptPath() & "\MFDL.tmp"
flagSelektierteBilder = false

'berprfen ob Rahmendatei vorhanden
if not objFS.FileExists(RahmenDatei) then
	msgbox "Zur Verwendung des Skripts muss die Rahmendatei" & vbNewLine & _
		   "MFDL.cfg im FF-Datenverzeichnis vorhanden sein." & vbNewLine & vbNewLine& _ 
		   "Da die Datei fehlt, wird das Skript abgebrochen!",vbExclamation,"Abbruch"
	exit sub
end if

'ggf. BackUp anlegen
if flag_BackUp then
	Antwort = msgbox("Das Skript manipuliert die Rahmendatei MFDL.cfg" & vbNewLine & _
				 	"im FF-Datenverzeichnis." & vbNewLine & vbNewLine & _
				 	"Soll eine Sicherungsdatei MFDL_Backup.cfg angelegt werden?",vbQuestion + vbYesNoCancel,"Backup")
	if Antwort = vbCancel then exit sub
	if Antwort = vbYes then objFS.CopyFile RahmenDatei, BackUpDatei, True
end if

if FF_GetImageWidth() = 0 then
	if FF_GetImageCount = 0 then
		msgbox "Kein Bild geladen oder markiert!",vbCritical,"Abbruch"
		exit sub
	else
		flagSelektierteBilder = true
		imagecount = FF_GetImageCount
		Bild = FF_GetImageName(0)
		FF_LoadImage(Bild)
	end if
end if

OrigBreite = FF_GetImageWidth()	'Originalbreite
OrigHoehe = FF_GetImageHeight()	'Originalhhe

if Version_OK("3.02.25") then Markierung = 6 else Markierung = 2

'** Start Dialog MFDL-Toolbox **
FF_AddDialog "MFDL-Toolbox",419,323
FF_AddControl "MFDL-Toolbox","Listen","GROUP",274,14,131,62
FF_AddControl "MFDL-Toolbox","Rahmen bearbeiten","GROUP",274,78,131,22
FF_AddControl "MFDL-Toolbox","_","GROUP",363,301,40,20
FF_AddControl "MFDL-Toolbox","Rahmenvorschau","GROUP",5,5,260,260
FF_AddControl "MFDL-Toolbox","Vorschaubild","IMAGE",10,14,250,235
FF_AddControl "MFDL-Toolbox","AnzeigeRahmenname","SLEDIT",31,252,210,10
FF_SetControlStyle "MFDL-Toolbox","AnzeigeRahmenname",2049
FF_AddControl "MFDL-Toolbox","Rahmenliste","GROUP",269,5,141,297
FF_AddControl "MFDL-Toolbox","&Lschen","BUTTON",364,86,37,11
FF_AddControl "MFDL-Toolbox","&Umbenennen","BUTTON",322,86,37,11
FF_AddControl "MFDL-Toolbox","&Sortieren","BUTTON",280,86,37,11
FF_AddControl "MFDL-Toolbox","Rahmen verschieben","GROUP",274,103,131,22
FF_AddControl "MFDL-Toolbox","EinAus","BOOL",280,113,8,8
FF_SetControlStyle "MFDL-Toolbox","EinAus",16384
FF_AddControl "MFDL-Toolbox","&Ein/Aus","BUTTON",289,111,28,11
FF_AddControl "MFDL-Toolbox","Abbru&ch","BUTTON",326,111,30,11
FF_AddControl "MFDL-Toolbox","Hil&fe","BUTTON",364,111,37,11
FF_AddControl "MFDL-Toolbox","Rahmennamen","LISTBOX",274,130,131,141
FF_AddControl "MFDL-Toolbox","&1 = Anf.","BUTTON",278,271,26,11
FF_AddControl "MFDL-Toolbox","&2 = auf","BUTTON",310,271,26,11
FF_AddControl "MFDL-Toolbox","&3 = ab","BUTTON",343,271,26,11
FF_AddControl "MFDL-Toolbox","&4 = Ende","BUTTON",376,271,26,11
FF_AddControl "MFDL-Toolbox","&<   = Lupe","BUTTON",282,286,33,11
FF_AddControl "MFDL-Toolbox","&Vorschau","BUTTON",324,286,33,11
FF_AddControl "MFDL-Toolbox","Lupe   = &>","BUTTON",366,286,33,11
FF_AddControl "MFDL-Toolbox","Umwandlung","GROUP",5,270,114,32
FF_AddControl "MFDL-Toolbox","in &Promillewerte","BUTTON",10,288,48,11
FF_AddControl "MFDL-Toolbox","in &Absolutwerte","BUTTON",64,288,48,11
FF_AddControl "MFDL-Toolbox","&Reset","BUTTON",126,281,20,12
FF_AddControl "MFDL-Toolbox","Skalierung","GROUP",151,270,114,32
FF_AddControl "MFDL-Toolbox","flag_Staerke","BOOL",188,276,8,8
FF_AddControl "MFDL-Toolbox","Strke","STATIC",198,275,19,11
FF_AddControl "MFDL-Toolbox","flag_Position","BOOL",221,276,8,8
FF_AddControl "MFDL-Toolbox","Position","STATIC",232,275,19,11
FF_AddControl "MFDL-Toolbox","Skalierwert","STATIC",156,288,29,11
FF_AddControl "MFDL-Toolbox","Skalierwert%","SLEDIT",188,288,18,10
FF_SetControlStyle "MFDL-Toolbox","Skalierwert%",8194
FF_AddControl "MFDL-Toolbox","%","STATIC",209,288,7,11
FF_AddControl "MFDL-Toolbox","Ausf&hren","BUTTON",227,288,33,11
FF_AddControl "MFDL-Toolbox","?","BUTTON",10,307,11,11
FF_AddControl "MFDL-Toolbox","Speic&hern","BUTTON",118,307,33,11
FF_AddControl "MFDL-Toolbox","Ed&itor","BUTTON",171,307,33,11
FF_AddControl "MFDL-Toolbox","Rahmun&g","BUTTON",366,307,33,11
FF_AddControl "MFDL-Toolbox","Beschnit&t","BUTTON",227,307,33,11
FF_AddControl "MFDL-Toolbox","Backup","BUTTON",324,307,33,11
FF_AddControl "MFDL-Toolbox","&Beenden","BUTTON",282,307,33,11
FF_AddControl "MFDL-Toolbox","&d","BUTTON",44,307,1,1
FF_AddControl "MFDL-Toolbox","aller numerischen Rahmenwerte","STATIC",21,276,80,10
FF_SetControlStyle "MFDL-Toolbox","aller numerischen Rahmenwerte",1
FF_AddControl "MFDL-Toolbox","|","STATIC",23,307,24,11
FF_SetControlStyle "MFDL-Toolbox","|",1
FF_AddControl "MFDL-Toolbox","Update","BUTTON",49,307,33,11
FF_AddControl "MFDL-Toolbox","Listenauswahl","COMBO",280,24,121,10
FF_AddControl "MFDL-Toolbox","Neu","BUTTON",280,37,37,11
FF_AddControl "MFDL-Toolbox","Lschen","BUTTON",364,37,37,11
FF_AddControl "MFDL-Toolbox","Umbenennen","BUTTON",322,37,37,11
FF_AddControl "MFDL-Toolbox","||","STATIC",281,50,120,10
FF_SetControlStyle "MFDL-Toolbox","||",1
FF_AddControl "MFDL-Toolbox","Rahmen hinzufgen Ein/Aus","BUTTON",289,61,76,11
FF_AddControl "MFDL-Toolbox","Hin&zu","BUTTON",372,61,23,11
FF_AddControl "MFDL-Toolbox","RahmenHinzu","BOOL",280,63,8,8
FF_SetControlStyle "MFDL-Toolbox","RahmenHinzu",16384
FF_AddControl "MFDL-Toolbox","&x","BUTTON",44,307,1,1
FF_AddControl "MFDL-Toolbox","&y","BUTTON",44,307,1,1
'** End Dialog MFDL-Toolbox **

FF_SetControl "MFDL-Toolbox","flag_Staerke",1
FF_SetControl "MFDL-Toolbox","flag_Position",1
FF_SetControl "MFDL-Toolbox","Skalierwert%",100

FF_EnableControl "MFDL-Toolbox","Speic&hern",false
FF_EnableControl "MFDL-Toolbox","&Reset",false
FF_EnableControl "MFDL-Toolbox","Abbru&ch",false

'Listen
call ListenauswahlFuellen

call RegistryLesen ("TB")

if ListeAktuell <> "Standard" and objFS.FileExists(Listendatei) then
	call NeuEintrag (ListeAktuell)
	FF_SetControl "MFDL-Toolbox","Rahmennamen",RahmenAuswahl
	FF_EnableControl "MFDL-Toolbox","Umbenennen",true
	FF_EnableControl "MFDL-Toolbox","Lschen",true
else
	FF_EnableControl "MFDL-Toolbox","RahmenHinzu",false
	FF_EnableControl "MFDL-Toolbox","Rahmen hinzufgen Ein/Aus",false
	FF_EnableControl "MFDL-Toolbox","Hin&zu",false
end if
flagRahmenHinzu = 0

'Faktor
call Faktorenbestimmung
FF_PushImage() : PopZaehler = PopZaehler + 1

'Vorschau mit verkleinertem Bild
if boolVorschauVerkleinert then
	FF_HQScale MaxLaenge,MaxLaenge, true
	Breite=FF_GetImageWidth()		'Abmessungen der Verkleinerung
	Hoehe =FF_GetImageHeight()
	Referenz = MaxLaenge/1000 
	FaktorSV = MaxLaenge/LangeSeite 'Absolutwerte in Wertermittlung damit multiplizieren
	FF_PushImage() : PopZaehler = PopZaehler + 1
	call Vorschau
else
	FF_PushImage() : PopZaehler = PopZaehler + 1
	FaktorSV = 1
end if

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip 	"MFDL-Toolbox","in &Promillewerte", "" &_
							"in -Werte der lngsten Seite des gezeigten Bildes wandeln"
	FF_SetControlTooltip 	"MFDL-Toolbox","in &Absolutwerte", "" &_
							"in Pixelwerte wandeln auf Basis des gezeigten Bildes"
	FF_SetControlTooltip 	"MFDL-Toolbox","&Reset", "" &_
							"Rcksetzen von Umwandlung und/oder Skalierung"
	FF_SetControlTooltip 	"MFDL-Toolbox","Skalierwert%", "" &_
							"Vernderung von Strke und Position in %"
	FF_SetControlTooltip 	"MFDL-Toolbox","Ausf&hren", "" &_
							"Skalierung ausfhren"
	FF_SetControlTooltip 	"MFDL-Toolbox","&1 = Anf.", "" &_
							"Ersten Rahmen aktivieren mit Taste 1"
	FF_SetControlTooltip 	"MFDL-Toolbox","&2 = auf", "" &_
							"Vorherigen Rahmen aktivieren mit Taste 2"
	FF_SetControlTooltip 	"MFDL-Toolbox","&3 = ab", "" &_
							"Nchsten Rahmen aktivieren mit Taste 3"
	FF_SetControlTooltip 	"MFDL-Toolbox","&4 = Ende", "" &_
							"Letzten Rahmen aktivieren mit Taste 4"
	FF_SetControlTooltip 	"MFDL-Toolbox","&<   = Lupe", "" &_
							"Lupe ein/aus fr oberen linken Teil des Rahmens"
	FF_SetControlTooltip 	"MFDL-Toolbox","&Vorschau", "" &_
							"Vorschau des gewhlten Rahmens / Lupe aus"
	FF_SetControlTooltip 	"MFDL-Toolbox","Lupe   = &>", "" &_
							"Lupe ein/aus fr unteren rechten Teil des Rahmens"
	FF_SetControlTooltip 	"MFDL-Toolbox","?", "" &_
						 	"Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
						 	"vorausgesetzt es ist ein PDF-Reader installiert." & vbNewLine & _
						 	"Anderenfalls wird eine gekrzte Textversion angezeigt."
	FF_SetControlTooltip 	"MFDL-Toolbox","Update", "" &_
						 	"Prfung ob eine neue Version vorliegt."
	FF_SetControlTooltip 	"MFDL-Toolbox","Speic&hern", "" &_
							"Speichern des genderten Rahmens unter" & vbNewLine & _
							"einem einzugebenden Namen"
	FF_SetControlTooltip 	"MFDL-Toolbox","Ed&itor", "" &_
							"Anzeige und Editiermglichkeit der" & vbNewLine & _
							"aktuellen Rahmendefinitionen"
	FF_SetControlTooltip 	"MFDL-Toolbox","Beschnit&t", "" &_
							"Bildbeschnitt auf whlbares Seitenverhltnis" & vbNewLine & _
							"unter Bercksichtigung des aktuellen Rahmens"
	FF_SetControlTooltip 	"MFDL-Toolbox","&Beenden", "" &_
							"Skript vorzeitig beenden"
	FF_SetControlTooltip 	"MFDL-Toolbox","Backup", "" &_
							"Anlegen eines Backups der Rahmendatei"
	FF_SetControlTooltip 	"MFDL-Toolbox","Rahmun&g", "" &_
							"Rahmung des Bildes auf der Arbeitsflche oder," & vbNewLine & _
							"wenn dort keins vorhanden, Rahmung aller selek-" & vbNewLine & _
							"tierten Bilderim Computerverzeichnis mit" & vbNewLine & _
							"definierbaren Speicherparametern"
	FF_SetControlTooltip 	"MFDL-Toolbox","Neu", "" &_
							"Neue Liste anlegen"
	FF_SetControlTooltip 	"MFDL-Toolbox","Lschen", "" &_
							"Aktive Liste lschen / Standard nicht lschbar"
	FF_SetControlTooltip 	"MFDL-Toolbox","Umbenennen", "" &_
							"Umbenennen der aktuellen Liste"
	FF_SetControlTooltip 	"MFDL-Toolbox","Rahmen hinzufgen Ein/Aus", "" &_
							"Hinzufgen von Rahmen ein- bzw. ausschalten"
	FF_SetControlTooltip 	"MFDL-Toolbox","Hin&zu", "" &_
							"Hinzufgen von Rahmen aus der Standardliste"
	FF_SetControlTooltip 	"MFDL-Toolbox","&Lschen", "" &_
							"Unwiderrufliches Lschen des aktuellen Rahmens"
	FF_SetControlTooltip 	"MFDL-Toolbox","&Umbenennen", "" &_
							"Umbenennen des aktuellen Rahmens"
	FF_SetControlTooltip 	"MFDL-Toolbox","&Sortieren", "" &_
							"Sortieren aller Rahmen in alphanumerischre Reihenfolge"
	FF_SetControlTooltip 	"MFDL-Toolbox","&Ein/Aus", "" &_
							"Verschieben des aktivieren Rahmens in der Liste ein/aus" & vbNewLine & _
							"Verschiebung durchfhren mit Anf., auf, ab, Ende"
	FF_SetControlTooltip 	"MFDL-Toolbox","Abbru&ch", "" &_
							"Verschieben abbrechen ohne nderung"
	FF_SetControlTooltip 	"MFDL-Toolbox","Hil&fe", "" &_
							"Erluterung zum Verschieben von Rahmen"
end if

FF_ActivateControl "MFDL-Toolbox","&d"
FF_SetDialogTimer "MFDL-Toolbox", 100

do

	Select Case FF_ShowDialog ("MFDL-Toolbox")
	Case "&x"
		call Vorschau
		call Duplikatstest
	Case "&y"
		call Duplikatstest_All
	Case "&d"
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "TIMER"
		FF_SetControl "MFDL-Toolbox","|", "V " & Skriptversion
		FF_SetControl "MFDL-Toolbox","||","Liste " & """" & ListeAktuell & """" & " ist aktiv"
		FF_SetDialogTimer "MFDL-Toolbox", 0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Listenauswahl"
		ListeAktuell = FF_GetControl("MFDL-Toolbox","Listenauswahl")
		call NeuEintrag (ListeAktuell)
		if len(Rahmenauswahl) > 0 and ListeAktuell = "Standard" then
			FF_SetControl "MFDL-Toolbox","Rahmennamen",Rahmenauswahl
		end if
		call Vorschau
		if ListeAktuell = "Standard" then
			FF_EnableControl "MFDL-Toolbox","Umbenennen",false
			FF_EnableControl "MFDL-Toolbox","Lschen",false
			FF_EnableControl "MFDL-Toolbox","RahmenHinzu",false
			FF_EnableControl "MFDL-Toolbox","Rahmen hinzufgen Ein/Aus",false
		else
			FF_EnableControl "MFDL-Toolbox","Umbenennen",true
			FF_EnableControl "MFDL-Toolbox","Lschen",true
			FF_EnableControl "MFDL-Toolbox","RahmenHinzu",true
			FF_EnableControl "MFDL-Toolbox","Rahmen hinzufgen Ein/Aus",true
		end if
	Case "Neu"
		call ListeNeu
		call Vorschau
	Case "Umbenennen"
		call ListeUmbenennen
	Case "Lschen"
		call ListeLoeschen
		FF_EnableControl "MFDL-Toolbox","RahmenHinzu",false
		FF_EnableControl "MFDL-Toolbox","Rahmen hinzufgen Ein/Aus",false
		if len(Rahmenauswahl) > 0 then
			FF_SetControl "MFDL-Toolbox","Rahmennamen",Rahmenauswahl
		end if
		call Vorschau
	Case "RahmenHinzu","Rahmen hinzufgen Ein/Aus"
		if flagRahmenHinzu = 0 then
			flagRahmenHinzu = 1
			RahmenSumme = ""
			call AusEinblenden
			ListeAktuell = FF_GetControl("MFDL-Toolbox","Listenauswahl")
			call Rahmennamen_Liste				'Rahmennamen auslesen aus Rahmendatei MFDL.cfg
			call NeuEintrag	("Standard")		'und eintragen
			FF_SetControl "MFDL-Toolbox","Listenauswahl","Standard"
			FF_SetControl "MFDL-Toolbox","||","Rahmen kopieren in Liste " & """" & ListeAktuell & """"
			call ListeAuslesen (ListeAktuell)
			call Vorschau
		else
			flagRahmenHinzu = 0
			call AusEinblenden
			call RahmenHinzuEnde
		end if
		FF_SetControl "MFDL-Toolbox" ,"RahmenHinzu",flagRahmenHinzu
	Case "Hin&zu"
		call RahmnenInListe
	Case "&Lschen"
		RahmenAuswahl = FF_GetControl("MFDL-Toolbox","Rahmennamen")
		if len(RahmenAuswahl) > 0 then
			if ListeAktuell = "Standard" then
				Antwort = msgbox("Soll der Rahmen" & vbNewLine & "   " & RahmenAuswahl & vbNewLine & _
			  			"wirklich unwiderruflich gelscht werden?",vbYesNo + vbQuestion,"Sicherheitsabfrage")
			else
				Antwort = msgbox("Soll der Rahmen" & vbNewLine & "   " & RahmenAuswahl & vbNewLine & _
			  			"wirklich aus der Liste" & """" & ListeAktuell & """" & vbNewLine & _
			  			"entfernt werden?",vbYesNo + vbQuestion,"Sicherheitsabfrage")
			end if
			
			if Antwort = vbYes then
				if ListeAktuell = "Standard" then
					call Loeschen_Standard (RahmenAuswahl)
					call Loeschen_InAllenListen (RahmenAuswahl)
				else
					call Loeschen_InListe (RahmenAuswahl)
				end if
				
				if AnzeigeZeile <> "" then
					FF_SetControl "MFDL-Toolbox","Rahmennamen",AnzeigeZeile
				end if
				
				call Vorschau
			end if
		end if
	Case "&Umbenennen"
		call Vorschau
		RahmenAuswahl = FF_GetControl("MFDL-Toolbox","Rahmennamen")
		if len(RahmenAuswahl) > 0 then
			RahmenNeu = inputbox("Wie soll der Rahmen" & vbNewLine & "   " & RahmenAuswahl & vbNewLine & _
						 			"benannt werden?","Rahmenname",RahmenAuswahl)
			if len(RahmenNeu) > 0 then
				call Rahmennamentest (RahmenNeu)
				if not Abbruch then
					call RahmenUmbenennen_Standard
					call RahmenUmbenennen_InAllenListen
					call Rahmennamen_Liste	'Standardliste aktualisieren
					call NeuEintrag (ListeAktuell)
					FF_SetControl "MFDL-Toolbox","Rahmennamen",RahmenNeu
					call Vorschau
				end if
			end if
		end if
	Case "&Sortieren"
		if len(FF_GetControl("MFDL-Toolbox","Rahmennamen")) > 0 then
			TAnfang = Timer
			if not TAnzeige	then
				Antwort = msgbox("Sollen die Rahmen wirklich alphanumerisch sortiert werden?" & vbNewLine & _
				"Die vorhandene Anordnung geht dadurch verloren.",vbYesNo + vbQuestion,"Abfrage")
				if Antwort = vbYes then
					if ListeAktuell = "Standard" then
						call Sortieren_Standard
					else
						call Sortieren_Liste
					end if
					call Vorschau
				end if
			end if
			TEnde = Timer
			if TAnzeige then msgbox "Sortieren dauert " & round(TEnde - TAnfang,3) * 1000 & " ms"
		end if
	Case "EinAus"				'Verschiebung
		if FF_GetControl("MFDL-Toolbox","EinAus") = "1" then
			call Verschiebungen ("Ein")
		else
			call Verschiebungen ("Aus")
		end if
	Case "&Ein/Aus"				'Verschiebung
		if FF_GetControl("MFDL-Toolbox","EinAus") = "0" then
			FF_SetControl "MFDL-Toolbox","EinAus","1"
			call Verschiebungen ("Ein")
		else
			FF_SetControl "MFDL-Toolbox","EinAus","0"
			call Verschiebungen ("Aus")
		end if
	Case "Abbru&ch"				'Verschiebung
		if FF_GetControl("MFDL-Toolbox","EinAus") = "1" then
			if ListeAktuell = "Standard" then call Rahmennamen_Liste
			call NeuEintrag (ListeAktuell)
			FF_SetControl "MFDL-Toolbox","EinAus","0"
			FF_EnableControl "MFDL-Toolbox","Listenauswahl",true
			FF_EnableControl "MFDL-Toolbox","&Lschen",true
			FF_EnableControl "MFDL-Toolbox","&Umbenennen",true
			FF_EnableControl "MFDL-Toolbox","&Sortieren",true
		end if
	Case "Hil&fe"					'Verschiebung
		msgbox "Wenn Verschieben aktiviert ist, kann mit den Befehlsschaltflchen" & vbNewLine & _
			   "'1 = Anf.', '2 = auf', '3 = ab' oder '4 = Ende' bzw. den Tasten" & vbNewLine & _
			   "'1', '2', '3' oder '4' der gerade markierteRahmen verschoben werden." & vbNewLine & _
			   "Whrenddessen ist 'Lschen', 'Umbennen' und 'Sortieren' gesperrt." & vbNewLine & vbNewLine& _
			   "Mit 'Abbruch' wird die ursprngliche Reihenfolge wieder hergestellt." & vbNewLine & _
			   "Mit Deaktivierung durch nochmaliges Anklicken von 'Ein/Aus' wird die" & vbNewLine & _
			   "gerade bestehende Reihenfolge abgespeichert.",vbInformation,"Verschieben"
	Case "&1 = Anf."
		FF_SetControl "MFDL-Toolbox","Skalierwert%",100
		Skalierwert = 100
		if FF_GetControl("MFDL-Toolbox","EinAus") = "1" then
			call RahmenVerschiebung ("pos1")
		else
			Rahmenaktiv = ""
			VorschauRichtung = "pos1"
			call Vorschau
			VorschauRichtung = ""
		end if
	Case "&2 = auf"
		FF_SetControl "MFDL-Toolbox","Skalierwert%",100
		Skalierwert = 100
		if FF_GetControl("MFDL-Toolbox","EinAus") = "1" then
			call RahmenVerschiebung ("auf")
		else
			Rahmenaktiv = ""
			VorschauRichtung = "auf"
			call Vorschau
			VorschauRichtung = ""
		end if
	Case "&3 = ab"
		FF_SetControl "MFDL-Toolbox","Skalierwert%",100
		Skalierwert = 100
		if FF_GetControl("MFDL-Toolbox","EinAus") = "1" then
			call RahmenVerschiebung ("ab")
		else
			Rahmenaktiv = ""
			VorschauRichtung = "ab"
			call Vorschau
			VorschauRichtung = ""
		end if
	Case "&4 = Ende"
		FF_SetControl "MFDL-Toolbox","Skalierwert%",100
		Skalierwert = 100
		if FF_GetControl("MFDL-Toolbox","EinAus") = "1" then
			call RahmenVerschiebung ("ende")
		else		
			Rahmenaktiv = ""
			VorschauRichtung = "ende"
			call Vorschau
			VorschauRichtung = ""
		end if
	Case "&<   = Lupe"		'links oben
	 	if LupeLinksEin = 0 then
	 		LupeLinksEin = 1
	 		LupeRechtsEin = 0
	 	else
	 		LupeLinksEin = 0
	 	end if
		call Vorschau
	Case "&Vorschau"
		FF_SetControl "MFDL-Toolbox","Skalierwert%",100
		Skalierwert = 100
	 	LupeRechtsEin = 0 : LupeLinksEin = 0		
		call Vorschau
	Case "Rahmennamen"
		FF_SetControl "MFDL-Toolbox","Skalierwert%",100
		Skalierwert = 100
		call Vorschau
	Case "Lupe   = &>"		'rechts unten
	 	if LupeRechtsEin = 0 then
	 		LupeRechtsEin = 1
	 		LupeLinksEin = 0
	 	else
	 		LupeRechtsEin = 0
	 	end if
		call Vorschau
	Case "in &Promillewerte"	'Umwandlung
		call Vorschau
		call UmrechnungPromille(RahmenAktuell)
		FF_EnableControl "MFDL-Toolbox","Speic&hern",true
		FF_EnableControl "MFDL-Toolbox","&Reset",true
		ProtokollKopf = Protokollkopf & "Umrechnung in Promillewerte" & vbNewLine
		Protokoll = ProtokollKopf & vbNewline & RahmenAktuell
	Case "in &Absolutwerte"	'Umwandlung
		call Vorschau
		call UmrechnungAbsolut(RahmenAktuell)
		FF_EnableControl "MFDL-Toolbox","Speic&hern",true
		FF_EnableControl "MFDL-Toolbox","&Reset",true
		ProtokollKopf = Protokollkopf & "Umrechnung in Absolutwerte" & vbNewLine
		Protokoll = ProtokollKopf & vbNewline & RahmenAktuell
	Case "&Reset"
		FF_SetControl "MFDL-Toolbox","Skalierwert%",100
		Skalierwert = 100
		flag_Reset = true
		call Vorschau
	Case "Ausf&hren"	'Skalierung
		call Vorschau
		if FF_GetControl("MFDL-Toolbox","flag_Staerke") = 0 and FF_GetControl("MFDL-Toolbox","flag_Position") = 0 then
			WshShell.Popup "Strke und/oder Position muss aktiviert werden!",,"Meldung",vbExclamation
		else	
			Skalierwert = FF_GetControl("MFDL-Toolbox","Skalierwert%")
			if Skalierwert = "" then
				FF_SetControl "MFDL-Toolbox","Skalierwert%",100
				Skalierwert = 100
			else
				Skalierwert = Skalierwert * 1
			end if
		
			if Skalierwert > 0 and Skalierwert <> 100 then

				Skalierwert = Skalierwert/100
				if FF_GetControl("MFDL-Toolbox","flag_Staerke") = 1 then 
					SkalierwertSt = Skalierwert
					msg1 = "Nur Strkeskalierung mit Faktor " & Skalierwert
				else
					SkalierwertSt = 1
				end if
				if FF_GetControl("MFDL-Toolbox","flag_Position") = 1 then
					SkalierwertPo = Skalierwert
					msg1 = "Nur Positionsskalierung mit Faktor " & Skalierwert
				else
					SkalierwertPo = 1
				end if
				if FF_GetControl("MFDL-Toolbox","flag_Staerke") = 1 and FF_GetControl("MFDL-Toolbox","flag_Position") = 1 then
					msg1 = "Strke- und Positionsskalierung mit Faktor " & Skalierwert
				end if
				
				FF_PopImage() : PopZaehler = PopZaehler - 1
				FF_PushImage() : PopZaehler = PopZaehler + 1
				
				Anzahl = 0
				call RahmenErstellung (RahmenAktuell)
				
				FF_SetControl "MFDL-Toolbox","Vorschaubild",0
				FF_EnableControl "MFDL-Toolbox","Speic&hern",true
				FF_EnableControl "MFDL-Toolbox","&Reset",true
				
				ProtokollKopf = Protokollkopf & msg1 & vbNewLine
				Protokoll = ProtokollKopf & vbNewline & RahmenAktuell
				
				call Vorschau
				
			end if
		end if
	Case "?"	'Kurzbeschreibung
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\MFDL_Toolbox\MFDL_Toolbox.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if Err.Number <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?)." & vbNewLine & vbNewLine &_
				   "Ersatzweise erfolgt eine Textanzeige!",vbExclamation,"Hinweis"
			err.clear
			
			if not KBvorhanden then	call KurzbeschreibungLesen
			if KBvorhanden then
				call KurzbeschreibungAnzeigen
			else
				msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
			end if
			
		end if
		on error GoTo 0
	Case "Speic&hern"
		call Rahmen_Speichern
		if not Abbruch then
			FF_SetControl "MFDL-Toolbox","Skalierwert%",100
			Skalierwert = 100
			if ListeAktuell <> "Standard" then
				call NeuEintrag (ListeAktuell)
				flag_Reset = true
				call Vorschau
			end if
		end if
	Case "Ed&itor"
		call EditorAufruf
	Case "Rahmun&g"
		SkalierwertSt = 1 : SkalierwertPo = 1 : FaktorSV = 1 : Anzahl = 0 : AnzB = 0
		if flagSelektierteBilder then								'wenn wahr werden alle im Computerverzeichnis
																	'	selektierten Bilder gerahmt und gespeichert
			call SpeicherParameter									'Namensergnzung (Prefix oder Suffix) festlegen
			
			if not Abbruch then
				
				for n = 0 to imagecount -1
					Bild = FF_GetImageName(n)
					OriginalBild = Bild
					FF_LoadImage(Bild)
					
					call Faktorenbestimmung
					call RahmenErstellung (RahmenAktuell)

					Pfad = objFS.GetParentFolderName(Bild)						'|
					File = objFS.GetBaseName(Bild)								'|
					Ext  = objFS.GetExtensionName(Bild)							'|
																				'|
					if boolSuffix then											' > Speichername ermitteln
						Bild = objFS.BuildPath(Pfad,File & Zusatz & "." & Ext)	'|
					else														'|
						Bild = objFS.BuildPath(Pfad,Zusatz & File & "." & Ext)	'|
					end if														'|	
					
					if flag_Copy then call BildCopy : FF_Reload()	'Kopieren des Originals in das gerahmte Bild weil im
																	'	Rahmentext steht: "vorher Bild kopieren; danach einfgen"
					call FF_SaveImage(Bild,quality)					'Gerahmtes Bild speichern
					AnzB = AnzB +1
				next
				flag_RahmungSB = true								'Erfolgsmeldung
				exit do
			end if
		else
			FF_PopImage() : PopZaehler = PopZaehler - 1
			FF_PopImage() : PopZaehler = PopZaehler - 1
			call Faktorenbestimmung
			call RahmenErstellung (RahmenAktuell)
			if flag_Copy then call BildCopy							'Kopieren des Originals in das gerahmte Bild weil im
																	'	Rahmentext steht: "vorher Bild kopieren; danach einfgen"
			FF_Reload()
			exit do
		end if
	Case "Beschnit&t"
		Dim Rahmenzeilen,Rahmen,Wert
		Dim Vli,Vob,Vre,Vun,i,m
		Rahm_Wert = 1	'Pixelwerte

		SkalierwertSt = 1 : SkalierwertPo = 1 : FaktorSV = 1 : Anzahl = 0 : AnzB = 0
		if flagSelektierteBilder then								'wenn wahr werden alle im Computerverzeichnis
																	'	selektierten Bilder gerahmt und gespeichert
			call SpeicherParameter									'Namensergnzung (Prefix oder Suffix) festlegen
			if not Abbruch then call SV_Wahl						'Auswahl bzw. Bestimmung des Seitenverhltnis
			
			if not Abbruch then
				for i = 0 to imagecount -1
					Bild = FF_GetImageName(i)
					OriginalBild = Bild
					FF_LoadImage(Bild)
					OrigBreite = FF_GetImageWidth()	'Originalbreite
					OrigHoehe = FF_GetImageHeight()	'Originalhhe

					call Faktorenbestimmung
					Vli = 0 : Vob = 0 : Vre = 0 : Vun = 0

					Rahmenzeilen = split(RahmenAktuell,vbNewLine)
					for each Rahmen in Rahmenzeilen
						if Rahmen = "" then exit for
						if instr(Rahmen,"Bild um Farbe erweitern") > 0 then
							Wert = split(Rahmen,",")
							if Wert(1) = 1 then			'Promillewerte umrechnen in Pixel
								for m = 2 to 5
									Wert(m) = round(Wert(m) * Originalreferenz)
								next
							else
								Rahm_Wert = 2			'Absolutwerte
							end if
							Vli = Vli + Wert(2) * 1		'links
							Vob = Vob + Wert(3) * 1		'oben
							Vre = Vre + Wert(4) * 1		'rechts
							Vun = Vun + Wert(5) * 1		'unten
						end if
					next
					
					if i > 0 then SchnittTextSperre = true
					call Beschnitt (Vli + Vre, Vob + Vun)
					
					if not Abbruch then
						Pfad = objFS.GetParentFolderName(Bild)						'|
						File = objFS.GetBaseName(Bild)								'|
						Ext  = objFS.GetExtensionName(Bild)							'|
																					'|
						if boolSuffix then											' > Speichername ermitteln
							Bild = objFS.BuildPath(Pfad,File & Zusatz & "." & Ext)	'|
						else														'|
							Bild = objFS.BuildPath(Pfad,Zusatz & File & "." & Ext)	'|
						end if														'|	
						
						if flag_Copy then call BildCopy : FF_Reload()	'Kopieren des Originals in das gerahmte Bild weil im
																		'	Rahmentext steht: "vorher Bild kopieren; danach einfgen"
						call FF_SaveImage(Bild,quality)					'Gerahmtes Bild speichern
						AnzB = AnzB +1
					else
						Abbruch = false
					end if
				next
				
				if not Abbruch then flag_RahmungSB = true							'Erfolgsmeldung
				exit do
			end if
		else
			call Vergr_Info (false)
			if Abbruch then exit do
		end if
	Case "Vorschaubild"
		call Vergr_Info (true)
		if Rahm_Wert = 0 then
			iText = "- Das aktuelle Bild wird durch den Rahmen nicht vergert."
		else
			iText = "- Das aktuelle Bild wird durch den Rahmen vergert."
		end if
		
		WshShell.Popup ProtokollKopf & iText & vbNewline & vbNewLine & RahmenAktuell,,"Protokoll und Rahmentext",vbInformation
	
	Case "Backup"
		Antwort = msgbox("Das Skript manipuliert die Rahmendatei MFDL.cfg" & vbNewLine & _
				 	"im FF-Datenverzeichnis." & vbNewLine & vbNewLine & _
				 	"Soll eine Sicherungsdatei MFDL_Backup.cfg angelegt werden?",vbQuestion + vbYesNoCancel,"Backup")
		if Antwort = vbCancel then exit sub
		if Antwort = vbYes then objFS.CopyFile RahmenDatei, BackUpDatei, True
	Case "CANCEL", "&Beenden"
		do while PopZaehler > 0
			FF_PopImage() : PopZaehler = PopZaehler - 1
		loop
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben ("TB")
FF_CloseDialog ("MFDL-Toolbox")
if flag_RahmungSB then
	WshShell.Popup AnzB & " von " & imagecount & " ausgewhlten Bilder wurden gerahmt.",,"Erfolgsmeldung",vbInformation
end if

if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen

End Sub
'------------------------------------------------------------------------
Sub Rahmennamen_Liste
'Rahmendatei wird Zeile fr Zeile ausgelesen und in das ListenArray geschrieben
Dim RahmenZeile,tmpString

'Rahmendatei wird Zeile fr Zeile ausgelesen
Liste = ""
Set RahmenZeile = objFS.OpenTextFile(RahmenDatei, ForReading)
Do
	tmpString = RahmenZeile.ReadLine
	if tmpString = "" then exit do
	if instr(tmpString,"#") = 1 then
		Liste = Liste & mid(tmpString,2) & "/"
	end if
loop Until RahmenZeile.AtEndOfStream
RahmenZeile.Close

ListenArray = split(Liste,"/")
ListeMax = UBound(ListenArray) - 1

End Sub
'------------------------------------------------------------------------
Sub NeuEintrag (RListe)
Dim Array,element

'Neueintrag in die Rahmenliste
FF_SetControl "MFDL-Toolbox","Rahmennamen",""
if RListe = "Standard" then
	for n = 0 to ListeMax
		FF_SetControl "MFDL-Toolbox","Rahmennamen",ListenArray(n)
	next
	Rahmenauswahl = ListenArray(0)
else
	call ListeAuslesen (RListe)
	Array = split(RahmenSumme,vbNewLine)
	for each element in Array
		FF_SetControl "MFDL-Toolbox","Rahmennamen",element
	next
end if

FF_SetControl "MFDL-Toolbox","||","Liste " & """" & RListe & """" & " ist aktiv"

End Sub
'------------------------------------------------------------------------
Sub Faktorenbestimmung

Breite=FF_GetImageWidth()	'Breite
Hoehe =FF_GetImageHeight()	'Hoehe

if Breite >= Hoehe then
	Referenz = Breite/1000
	Faktor = 1000/Breite
	LangeSeite = Breite
else
	Referenz = Hoehe/1000
	Faktor = 1000/Hoehe
	LangeSeite = Hoehe
end if
Originalreferenz = Referenz

End Sub
'------------------------------------------------------------------------
Sub Vorschau
'markierter Rahmen wird gesucht, Rahmung durchgefhrt und als Vorschau angezeigt
Dim Datei, RahmenKomplett,DateiArray,DateiArray1,Pos,Rahmenarray
Dim RahmenAktuellOK : RahmenAktuellOK = false
flag_Copy = false

		SkalierwertSt = 1 : SkalierwertPo = 1
		FF_PopImage() : PopZaehler = PopZaehler - 1
		FF_PushImage() : PopZaehler = PopZaehler + 1

RahmenAuswahl = FF_GetControl("MFDL-Toolbox","Rahmennamen")

if Rahmenaktiv <> RahmenAuswahl or flag_Reset then

	flag_Reset = false

	FF_EnableControl "MFDL-Toolbox","Speic&hern",false
	FF_EnableControl "MFDL-Toolbox","&Reset",false
	RahmenAktuell = ""

	Set Datei = objFS.OpenTextFile(RahmenDatei, ForReading)
	RahmenKomplett = Datei.ReadAll
	Datei.Close
	RahmenKomplett = mid(RahmenKomplett,2)
	
	if ListeAktuell = "" or ListeAktuell = "Standard" or flagRahmenHinzu = 1 then
		DateiArray = split(RahmenKomplett,"#")
	else
		DateiArray1 = split(RahmenKomplett,"#")
		call ListeAuslesen (ListeAktuell)
		DateiArray = split(RahmenSumme,vbNewLine)
	end if

	select case VorschauRichtung
		case "pos1"
			RahmenAktuell = DateiArray(0)
		case "auf"
			for n = 0 to ubound(DateiArray)
				Rahmenarray = split(DateiArray(n),vbNewLine)
				if Rahmenarray(0) = RahmenAuswahl then
					if n > 0 then 
						RahmenAktuell = DateiArray(n - 1)
					else
						RahmenAktuell = DateiArray(0)
					end if
					exit for
				end if
			next
		case "ab"
			for n = 0 to ubound(DateiArray)
				Rahmenarray = split(DateiArray(n),vbNewLine)
				if Rahmenarray(0) = RahmenAuswahl then
					if n < ubound(DateiArray) then 
						RahmenAktuell = DateiArray(n + 1)
					else
						RahmenAktuell = DateiArray(ubound(DateiArray))
					end if
					exit for
				end if
			next
		case "ende"
			RahmenAktuell = DateiArray(ubound(DateiArray))
		case else
			for n = 0 to ubound(DateiArray)
				Rahmenarray = split(DateiArray(n),vbNewLine)
				if Rahmenarray(0) = RahmenAuswahl then
					RahmenAktuell = DateiArray(n)
					exit for
				end if
			next
	end select
	
	Rahmenaktiv = RahmenAuswahl
	if len(RahmenAktuell) = 0 then exit sub
	
	if ListeAktuell = "" or ListeAktuell = "Standard" or flagRahmenHinzu = 1 then
		'Rahmenaktuell bekannt
		RahmenAktuellOK = true
	else
		RahmenAuswahl = RahmenAktuell
		for n = 0 to ubound(DateiArray1)
			Rahmenarray = split(DateiArray1(n),vbNewLine)
			if Rahmenarray(0) = RahmenAuswahl then
				RahmenAktuell = DateiArray1(n)
				RahmenAktuellOK = true
				exit for
			end if
		next
	end if
	
	if not RahmenAktuellOK then
		msgbox "Schwerer Vorschaufehler!" & vbNewLine & vbNewLine & _
		   	"Der Rahmen " & """" & RahmenAuswahl & """" & vbNewLine & _
		   	"ist nicht in der Datei MDFL.cfg enthalten." & vbNewLine & _
		   	"Es wird empfohlen, den Rahmen aus der" & vbNewLine & _
		   	"aktuellen Liste zu lschen.",vbExclamation,"Abbruch"
		exit sub
	end if
	
	Pos = instr(RahmenAktuell,vbNewLine)
	RahmenAuswahl = left(RahmenAktuell,Pos -1)
	RahmenAktuell = mid(RahmenAktuell,Pos + 2)

	FF_SetControl "MFDL-Toolbox","Rahmennamen",RahmenAuswahl
	FF_SetControl "MFDL-Toolbox","AnzeigeRahmenname",RahmenAuswahl

	ProtokollKopf = RahmenAuswahl & vbNewLine & vbNewLine & "Vorschau" & vbNewline
	
	Anzahl = 0
	call RahmenErstellung (RahmenAktuell)
	
	if Absolutwerte then ProtokollKopf = Protokollkopf & "- Absolutwerte vorhanden" & vbNewLine
	if Promillewerte then ProtokollKopf = Protokollkopf & "- Promillewerte vorhanden" & vbNewLine
	Protokoll = ProtokollKopf & vbNewline & RahmenAktuell
else
	if flagRahmenHinzu = 1 then call RahmnenInListe
	Anzahl = 0
	call RahmenErstellung (RahmenAktuell)
end if

		call FF_YSharp(Schaerfegrad)
		call FF_Sharp(Schaerfegrad,true,true,true)

if LupeLinksEin = 1 then
	call FF_Crop(0,0,int(FF_GetImageWidth()/2),int(FF_GetImageHeight()/2))
	call FF_HQScale(MaxLaenge,MaxLaenge,true)
	FF_SetControl "MFDL-Toolbox","Vorschaubild",0
elseif LupeRechtsEin = 1 then
	call FF_Crop(int(FF_GetImageWidth()/2),int(FF_GetImageHeight()/2),int(FF_GetImageWidth()/2),int(FF_GetImageHeight()/2))
	call FF_HQScale(MaxLaenge,MaxLaenge,true)
	FF_SetControl "MFDL-Toolbox","Vorschaubild",0
else
	FF_SetControl "MFDL-Toolbox","Vorschaubild",0
end if

End Sub
'------------------------------------------------------------------------
Sub Loeschen_Standard (RahmenGewaehlt)
'Lschen des Rahmens RahmenGewaehlt in der Liste "Standard"
Dim RahmenZeile,ZielZeile,tmpString,geloescht
geloescht = false

FF_SetControl "MFDL-Toolbox","Rahmennamen",""

Set RahmenZeile = objFS.OpenTextFile(RahmenDatei, ForReading)
Set ZielZeile  = objFS.CreateTextFile(RahmenDateiTmp, True)

Do
	tmpString = RahmenZeile.ReadLine
	if tmpString = "#" & RahmenGewaehlt and not geloescht then
		geloescht = true
		do
			tmpString = RahmenZeile.ReadLine
			if left(tmpString,1) = "#" then
				AnzeigeZeile = mid(tmpString,2)
				exit do
			end if
		loop Until RahmenZeile.AtEndOfStream
	end if
	
	ZielZeile.WriteLine tmpString
	if left(tmpString,1) = "#" then 
		FF_SetControl "MFDL-Toolbox","Rahmennamen",mid(tmpString,2)
	end if	
	
loop Until RahmenZeile.AtEndOfStream

RahmenZeile.Close
ZielZeile.Close

objFS.CopyFile RahmenDateiTmp, RahmenDatei, True
objFS.DeleteFile (RahmenDateiTmp)

End Sub
'------------------------------------------------------------------------
Sub RahmenUmbenennen_Standard
'der Rahmen erhlt einen neuen Namen

Dim RahmenZeile,ZielZeile,tmpString

FF_SetControl "MFDL-Toolbox","Rahmennamen",""

Set RahmenZeile = objFS.OpenTextFile(RahmenDatei, ForReading)
Set ZielZeile  = objFS.CreateTextFile(RahmenDateiTmp, True)

Do
	tmpString = RahmenZeile.ReadLine
	if tmpString = "#" & Rahmenauswahl then
		tmpString = "#" & RahmenNeu
	end if
	
	ZielZeile.WriteLine tmpString
	
	if left(tmpString,1) = "#" then 
		FF_SetControl "MFDL-Toolbox","Rahmennamen",mid(tmpString,2)
	end if	
	
loop Until RahmenZeile.AtEndOfStream

RahmenZeile.Close
ZielZeile.Close

objFS.CopyFile RahmenDateiTmp, RahmenDatei, True
objFS.DeleteFile (RahmenDateiTmp)

End Sub
'------------------------------------------------------------------------
Sub Verschiebungen (Vorbereitung)

Select Case Vorbereitung
Case "Ein"

	FF_EnableControl "MFDL-Toolbox","Listenauswahl",false
	FF_EnableControl "MFDL-Toolbox","Neu",false
	FF_EnableControl "MFDL-Toolbox","Umbenennen",false
	FF_EnableControl "MFDL-Toolbox","Lschen",false
	FF_EnableControl "MFDL-Toolbox","RahmenHinzu",false
	FF_EnableControl "MFDL-Toolbox","Rahmen hinzufgen Ein/Aus",false
			
	FF_EnableControl "MFDL-Toolbox","Abbru&ch",true
	FF_EnableControl "MFDL-Toolbox","&Lschen",false
	FF_EnableControl "MFDL-Toolbox","&Umbenennen",false
	FF_EnableControl "MFDL-Toolbox","&Sortieren",false
	
	if ListeAktuell = "Standard" then
		call Rahmennamen_Liste
	else
		call ListeAuslesen (ListeAktuell)
		ListenArray = split(Rahmensumme,vbNewLine)
		ListeMax = UBound(ListenArray)
	end if
	
Case "Aus"

	if ListeAktuell = "Standard" then
		call RahmenReihenfolge_Speichern
	else
		Rahmensumme = join(ListenArray,vbNewline)
		call ListeSchreiben ("Schreiben")
	end if

	FF_EnableControl "MFDL-Toolbox","Listenauswahl",true
	FF_EnableControl "MFDL-Toolbox","Neu",true
	FF_EnableControl "MFDL-Toolbox","Umbenennen",true
	FF_EnableControl "MFDL-Toolbox","Lschen",true
	FF_EnableControl "MFDL-Toolbox","RahmenHinzu",true
	FF_EnableControl "MFDL-Toolbox","Rahmen hinzufgen Ein/Aus",true

	FF_EnableControl "MFDL-Toolbox","Abbru&ch",false
	FF_EnableControl "MFDL-Toolbox","&Lschen",true
	FF_EnableControl "MFDL-Toolbox","&Umbenennen",true
	FF_EnableControl "MFDL-Toolbox","&Sortieren",true
	
Case Else
End Select

End Sub
'------------------------------------------------------------------------
Sub RahmenVerschiebung (Richtung)
Dim tmpString,ZeileAktuell,m

call Vorschau

	Select Case Richtung
	Case "pos1"
		ZeileAktuell = FF_GetControl("MFDL-Toolbox","Rahmennamen")
		for n = 0 to ListeMax
			if ListenArray(n) = ZeileAktuell then
				if n = 0 then exit sub
				for m = n to 1 step -1
					ListenArray(m) = ListenArray(m-1)
				next
				ListenArray(0) = ZeileAktuell
				call NeuEintrag ("Standard")
				FF_SetControl "MFDL-Toolbox","Rahmennamen",ZeileAktuell
				exit for
			end if
		next
	Case "auf"
		ZeileAktuell = FF_GetControl("MFDL-Toolbox","Rahmennamen")
		for n = 0 to ListeMax
			if ListenArray(n) = ZeileAktuell then
				if n = 0 then exit sub
				tmpString = ListenArray(n-1)
				ListenArray(n-1) = ListenArray(n)
				ListenArray(n) = tmpString
				call NeuEintrag ("Standard")
				FF_SetControl "MFDL-Toolbox","Rahmennamen",ZeileAktuell
				exit for
			end if
		next
	Case "ab"
		ZeileAktuell = FF_GetControl("MFDL-Toolbox","Rahmennamen")
		for n = 0 to ListeMax
			if ListenArray(n) = ZeileAktuell then
				if n = ListeMax then exit sub
				tmpString = ListenArray(n+1)
				ListenArray(n+1) = ListenArray(n)
				ListenArray(n) = tmpString
				call NeuEintrag ("Standard")
				FF_SetControl "MFDL-Toolbox","Rahmennamen",ZeileAktuell
				exit for
			end if
		next
	Case "ende"
		ZeileAktuell = FF_GetControl("MFDL-Toolbox","Rahmennamen")
		for n = 0 to ListeMax
			if ListenArray(n) = ZeileAktuell then
				if n = ListeMax then exit sub
				for m = n to ListeMax - 1
					ListenArray(m) = ListenArray(m+1)
				next
				ListenArray(ListeMax) = ZeileAktuell
				call NeuEintrag ("Standard")
				FF_SetControl "MFDL-Toolbox","Rahmennamen",ZeileAktuell
				exit for
			end if
		next
	Case Else
	End Select

End Sub
'------------------------------------------------------------------------
Sub RahmenReihenfolge_Speichern
'Rahmen in der Reihenfolge speichern wie sie im ListenArray aufgelistet sind 
Dim Datei,RahmenKomplett,DateiArray,element,DateiNeu

Set Datei = objFS.OpenTextFile(RahmenDatei, ForReading, True)
RahmenKomplett = Datei.ReadAll
Datei.Close

DateiArray = split(RahmenKomplett,"#")
n = 0

do
	for each element in DateiArray
		if instr(element,ListenArray(n)) = 1 then
			DateiNeu = DateiNeu & "#" & element
			n = n + 1
			if n > ListeMax then exit do
		end if
	next
	FF_SetProgressText n,ListeMax,"Speichervorgang"
loop

Set Datei = objFS.OpenTextFile(RahmenDatei, ForWriting, True)
Datei.Write DateiNeu
Datei.Close

FF_SetProgressText 0,1,""

End Sub
'------------------------------------------------------------------------
Sub UmrechnungPromille (Rahmen)
'RahmenAktuell (= Rahmen) wird umgerechnet in Promillewerte
Dim Rahmenzeilen, ZeileNeu,flagUmwandlung

flagUmwandlung = false

Rahmenzeilen = split(Rahmen,vbNewLine)
for each Rahmenart in Rahmenzeilen
	if Rahmenart = "" then exit for

	WertArray = split(RahmenArt,",")
	
if WertArray(0) <> "Text einblenden" then	
	if WertArray(1) = 0 then				'Strke in Pixel
		if WertArray(2) > 0 or WertArray(3) > 0 or WertArray(3) > 0 or WertArray(3) > 0 then flagUmwandlung = true
		'Umrechnung in Promille
		WertArray(1) = 1
		for n = 2 to 5
			WertArray(n) = WertArray(n) * Faktor
			if WertArray(n) > 0 and WertArray(n) < 1 then WertArray(n) = 1 else WertArray(n) = round(WertArray(n))
		next
	end if
end if	

	if WertArray(6) = 0 then				'Position in Pixel
		if WertArray(7) > 0 or WertArray(8) > 0 or WertArray(9) > 0 or WertArray(10) > 0 then flagUmwandlung = true
		'Umrechnung in Promille
		WertArray(6) = 1
		for n = 7 to 10
			WertArray(n) = WertArray(n) * Faktor
			if WertArray(n) > 0 and WertArray(n) < 1 then WertArray(n) = 1 else WertArray(n) = round(WertArray(n))
		next
	end if

ZeileNeu = ZeileNeu & Join(WertArray,",") & vbNewLine

next

RahmenAktuell = ZeileNeu
if flagUmwandlung then
	msg = "Der Rahmen beinhaltet jetzt nur noch Promillewerte!" & vbNewLine & _
		  "Mit 'Reset' oder Auswahl eines neuen Rahmens werden die" & vbNewLine & _
		  "gewandelten Werte wieder zurckgesetzt auf Absolutwerte." & vbNewLine & vbNewLine & _
		  "Es wird daher empfohlen den genderten Rahmen zu speichern."
	WshShell.Popup msg,,"Hinweis",vbInformation

else
	msg = "Der Rahmen beinhaltet bereits nur Promillewerte!" & vbNewLine & _
		  "Es erfolgt daher keine Umwandlung."
	WshShell.Popup msg,,"Hinweis",vbInformation
end if

FF_EnableControl "MFDL-Toolbox","in &Promillewerte",false
FF_EnableControl "MFDL-Toolbox","in &Absolutwerte",true

End Sub
'------------------------------------------------------------------------
Sub UmrechnungAbsolut(Rahmen)
'RahmenAktuell (= Rahmen) wird umgerechnet in Absolutwerte
Dim Rahmenzeilen, ZeileNeu,flagUmwandlung

flagUmwandlung = false

Rahmenzeilen = split(Rahmen,vbNewLine)
for each Rahmenart in Rahmenzeilen
	if Rahmenart = "" then exit for
	
	
	WertArray = split(RahmenArt,",")
	
if WertArray(0) <> "Text einblenden" then	
	if WertArray(1) = 1 then				'Strke in Promille
	if WertArray(2) > 0 or WertArray(3) > 0 or WertArray(3) > 0 or WertArray(3) > 0 then flagUmwandlung = true
		'Umrechnung in Absolutwerte
		WertArray(1) = 0
		for n = 2 to 5
			WertArray(n) = WertArray(n) * Originalreferenz
			if WertArray(n) > 0 and WertArray(n) < 1 then WertArray(n) = 1 else WertArray(n) = round(WertArray(n))
		next
	end if
end if	

	if WertArray(6) = 1 then				'Position in Promille
	if WertArray(7) > 0 or WertArray(8) > 0 or WertArray(9) > 0 or WertArray(10) > 0 then flagUmwandlung = true
		'Umrechnung in Absolutwerte
		WertArray(6) = 0
		for n = 7 to 10
			WertArray(n) = WertArray(n) * Originalreferenz
			if WertArray(n) > 0 and WertArray(n) < 1 then WertArray(n) = 1 else WertArray(n) = round(WertArray(n))
		next
	end if

ZeileNeu = ZeileNeu & Join(WertArray,",") & vbNewLine

next

RahmenAktuell = ZeileNeu
if flagUmwandlung then
	msg = "Der Rahmen beinhaltet jetzt nur noch Absolutwerte!" & vbNewLine & _
		  "Mit 'Reset' oder Auswahl eines neuen Rahmens werden die" & vbNewLine & _
		  "gewandelten Werte wieder zurckgesetzt auf Promillewerte." & vbNewLine & vbNewLine & _
		  "Es wird daher empfohlen den genderten Rahmen zu speichern."
	WshShell.Popup msg,,"Hinweis",vbInformation
else
	msg = "Der Rahmen beinhaltet bereits nur Absolutwerte!" & vbNewLine & _
		  "Es erfolgt daher keine Umwandlung."
	WshShell.Popup msg,,"Hinweis",vbInformation
end if

FF_EnableControl "MFDL-Toolbox","in &Promillewerte",true
FF_EnableControl "MFDL-Toolbox","in &Absolutwerte",false

End Sub
'------------------------------------------------------------------------
Sub Rahmen_Speichern
'Der modifizierte Rahmen wird gespeichert
Dim RahmenNeu, Datei

RahmenErsetzen = false
RahmenAuswahl = FF_GetControl("MFDL-Toolbox","Rahmennamen")

do
	msg = "Geben Sie einen neuen Namen" & vbNewLine & "fr den Rahmen ein!"
	RahmenNeu = InputBox(msg,"Rahmenname",RahmenAuswahl)

	if RahmenNeu = "" then
		Abbruch = true
		exit sub
	end if
	
	call Rahmennamentest (RahmenNeu)
	if Abbruch then exit sub
	
	call Rahmennamen_Liste
	if instr(Liste,RahmenNeu & "/") > 0 then
		Antwort = msgbox("Der Name" & vbNewLine & "   " & RahmenNeu & vbNewLine & "ist bereits vergeben" & _
			vbNewLine & vbNewLine & "Soll er berschrieben werden?",vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			RahmenErsetzen = true
			exit do
		end if
	else
		exit do
	end if
loop

Set Datei = objFS.OpenTextFile(RahmenDatei,ForAppending,true)	'Standard
Datei.Write "#" & RahmenNeu & vbNewLine & RahmenAktuell
Datei.Close

if ListeAktuell <> "Standard" then								'und wenn <> Standard
	if Rahmensumme = "" then
		Rahmensumme = RahmenNeu
	else
		Rahmensumme = Rahmensumme & vbNewLine & RahmenNeu
	end if
	ListeSchreiben ("Schreiben")
end if

if RahmenErsetzen then
	call Loeschen_Standard (RahmenNeu)
	RahmenErsetzen = false
end if

call Rahmennamen_Liste
call NeuEintrag ("Standard")

FF_SetControl "MFDL-Toolbox","Rahmennamen",RahmenNeu

		FF_EnableControl "MFDL-Toolbox","Speic&hern",false
		FF_EnableControl "MFDL-Toolbox","&Reset",false

RahmenAuswahl = FF_GetControl("MFDL-Toolbox","Rahmennamen")
ProtokollKopf = RahmenAuswahl & vbNewLine & vbNewLine & "Vorschau" & vbNewline
Protokoll = ProtokollKopf & vbNewline & RahmenAktuell

End Sub
'------------------------------------------------------------------------
Sub SpeicherParameter
Dim OK

Abbruch = false
msg = "Es werden " & imagecount & " Bilder gerahmt und gespeichert."

'** Start Dialog Speicherparameter **
FF_AddDialog "Speicherparameter",200,81
FF_AddControl "Speicherparameter",msg,"STATIC",5,5,121,11
FF_AddControl "Speicherparameter","Namenszusatz","GROUP",5,20,128,36
FF_AddControl "Speicherparameter","boolSuffix","BOOL",74,31,8,8
FF_SetControlStyle "Speicherparameter","boolSuffix",16384
FF_AddControl "Speicherparameter","Suffix (angehngt)","STATIC",83,29,48,11
FF_AddControl "Speicherparameter","boolPraefix","BOOL",9,31,8,8
FF_SetControlStyle "Speicherparameter","boolPraefix",16384
FF_AddControl "Speicherparameter","Prfix (vorangestellt)","STATIC",18,29,52,11
FF_AddControl "Speicherparameter","Zusatz","SLEDIT",27,43,80,10
FF_AddControl "Speicherparameter","JPEG-Qualitt","GROUP",139,20,54,36
FF_AddControl "Speicherparameter","0 = FF-Einstellung","STATIC",144,29,47,11
FF_AddControl "Speicherparameter","quality","SLEDIT",145,43,33,10
FF_SetControlStyle "Speicherparameter","quality",8194
FF_AddControl "Speicherparameter","%","STATIC",181,43,8,11
FF_AddControl "Speicherparameter","Abbruch beendet den Rahmungsvorgang!","STATIC",5,63,103,10
FF_AddControl "Speicherparameter","Abbruch","BUTTON",113,63,33,11
FF_AddControl "Speicherparameter","OK","BUTTON",160,63,33,11
'** End Dialog Speicherparameter **

call RegistryLesen ("SP")

do	
	FF_ActivateControl "Speicherparameter","OK"
	
	Select Case FF_ShowDialog ("Speicherparameter")

	Case "boolSuffix"
		FF_SetControl "Speicherparameter","boolSuffix","1"
		FF_SetControl "Speicherparameter","boolPraefix","0"
	Case "boolPraefix"
		FF_SetControl "Speicherparameter","boolSuffix","0"
		FF_SetControl "Speicherparameter","boolPraefix","1"
	Case "OK"
		OK = true
		Zusatz = FF_GetControl("Speicherparameter","Zusatz")
		if Zusatz = "" then
			Antwort = msgbox("Achtung: Ohne Zusatztext werden die Originalbilder mit ihrer gerahmten Version berschrieben!" & _
				vbNewline &  "Soll die Rahmung durchgefhrt werden?",vbQuestion + vbYesNo,"Sicherheitsabfrage")
			if Antwort = vbYes then OK = true else OK = false
		end if
		
		if OK then
			OK = false
			boolSuffix = FF_GetControl("Speicherparameter","boolSuffix") * -1
		
			quality = FF_GetControl("Speicherparameter","quality")
			if quality = "" then quality = 0 else quality = quality * 1
			if quality >= 0 and quality <= 100 then
				OK = true
			else
				WshShell.Popup "Die JPEG-Qualitt muss zwischen 0 und 100 liegen!",,"Warnung",vbCritical
			end if
		
			Zusatz = FF_GetControl("Speicherparameter","Zusatz")
			call Dateinamentest (Zusatz)
			if Abbruch then
				WshShell.Popup "Der Namenszusatz darf keins der Zeichen " & VerbZ & " oder " & """" & " enthalten!",,"Warnung",vbCritical
			end if
		end if
		if OK and not Abbruch then exit do
	Case "CANCEL","Abbruch"
		Abbruch = true
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben ("SP")
FF_CloseDialog ("Speicherparameter")

End Sub
'------------------------------------------------------------------------
Sub Dateinamentest (Dateiname)
'Untersuchung auf unzulssige Zeichen
Dim Zeichen,Element
Abbruch = false

Zeichen = split(VerbZ,",")
for each Element in Zeichen
	if instr(Dateiname,Element) > 0 then
		msgbox "Die Zeichen " & VerbZ & " sind nicht zulssig!",vbExclamation,"Abbruch"
		Abbruch = true
		exit sub
	end if
next

if instr(Dateiname,"""") > 0 then
	Element = """"
	Abbruch = true
end if

End Sub
'------------------------------------------------------------------------
Sub Rahmennamentest (TestRahmen)
'Untersuchung auf unzulssige Zeichen
Dim Zeichen,Element
Dim UnzZ : UnzZ = BZ & "," & EZ & "," & TZ
Abbruch = false

Zeichen = split(UnzZ,",")
for each Element in Zeichen
	if instr(TestRahmen,Element) > 0 then
		msgbox "Die Zeichen " & UnzZ & " sind nicht zulssig!",vbExclamation,"Abbruch"
		Abbruch = true
		exit sub
	end if
next

End Sub
'------------------------------------------------------------------------
Sub EditorAufruf
Dim RahmenSicherung,Datei,RahmenEditiert
Rahmentest = true

RahmenSicherung = RahmenAktuell

'Rahmen in Tmp-Datei schreiben
Set Datei = objFS.OpenTextFile(RahmenDateiTmp, ForWriting, True)
Datei.Write RahmenAktuell
Datei.Close

'Editoraufruf
WshShell.Run "notepad " + RahmenDateiTmp,1,true

'Editierten Rahmen auslesen
Set Datei = objFS.OpenTextFile(RahmenDateiTmp, ForReading, True)
RahmenEditiert =  Datei.ReadAll
Datei.Close
objFS.DeleteFile (RahmenDateiTmp)

if RahmenEditiert = RahmenSicherung then
	RahmenSicherung = ""
	exit sub
end if

'Editierten Rahmen zum RahmenAktuell machen
RahmenAktuell = RahmenEditiert
call Vorschau
if Abbruch then
	msgbox "Die Rahmenzeile" & vbNewLine & RahmenZeileText & vbNewLine & "hat einen Fehler." & vbNewLine & _
		   "Der Rahmen wird auf den alten Zustand zurck gesetzt!",vbInformation,"Hinweis"
	RahmenAktuell = RahmenSicherung
	call Vorschau
	Abbruch = false
else
	ProtokollKopf = Protokollkopf & "Rahmen editiert" & vbNewLine
	Protokoll = ProtokollKopf & vbNewline & RahmenAktuell
	FF_EnableControl "MFDL-Toolbox","&Reset",true
	FF_EnableControl "MFDL-Toolbox","Speic&hern",true
end if

Rahmentest = false

End Sub
'------------------------------------------------------------------------
Sub RahmenErstellung (Rahmen)
Dim ZeileNeu,Rahmenzeilen
flag_Copy = false

FF_EnableControl "MFDL-Toolbox","in &Promillewerte",false
FF_EnableControl "MFDL-Toolbox","in &Absolutwerte",false
Absolutwerte = false
Promillewerte = false

Rahmenzeilen = split(Rahmen,vbNewLine)
RahmenzeilenZahl = ubound(Rahmenzeilen)
if flagSelektierteBilder then RahmenzeilenZahl = RahmenzeilenZahl * imagecount

for each Rahmenart in Rahmenzeilen
	if Rahmenart = "" then exit for

	Anzahl = Anzahl + 1
	call WertErmittlung
	
	if flagSelektierteBilder then 
		msg = cstr(n+1) & "/" & cstr(imagecount) & " - " 
	else 
		msg = ""
	end if

	msg = msg & WertArray(0)
	FF_SetProgressText Anzahl,RahmenzeilenZahl,msg
	
	call Aufruf_Rahmenart

	if WertArray(0) <> "Text einblenden" then
		WertArray(2)  = round(WertArray(2) * SkalierwertSt)	'Strke
		WertArray(3)  = round(WertArray(3) * SkalierwertSt)
		WertArray(4)  = round(WertArray(4) * SkalierwertSt)
		WertArray(5)  = round(WertArray(5) * SkalierwertSt)
	end if	
	
		WertArray(7)  = round(WertArray(7) * SkalierwertPo)	'Position
		WertArray(8)  = round(WertArray(8) * SkalierwertPo)
		WertArray(9)  = round(WertArray(9) * SkalierwertPo)
		WertArray(10) = round(WertArray(10) * SkalierwertPo)
	
	ZeileNeu = ZeileNeu & Join(WertArray,",") & vbNewLine
	
	'+++ Umwandlung aktivieren +++++++++
	if WertArray(0) <> "Text einblenden" and WertArray(1) = 0 and _
		(WertArray(2) > 0 or WertArray(3) > 0 or WertArray(4) > 0 or WertArray(5)  > 0) or _
		 WertArray(6) = 0 and _
		(WertArray(7) > 0 or WertArray(8) > 0 or WertArray(9) > 0 or WertArray(10) > 0) then
		FF_EnableControl "MFDL-Toolbox","in &Promillewerte",true			'Umw. in Promille aktivieren
		Absolutwerte = true
	end if
	
	if WertArray(1) = 1 and _
		(WertArray(2) > 0 or WertArray(3) > 0 or WertArray(4) > 0 or WertArray(5)  > 0) or _
		 WertArray(6) = 1 and _
		(WertArray(7) > 0 or WertArray(8) > 0 or WertArray(9) > 0 or WertArray(10) > 0) then
		FF_EnableControl "MFDL-Toolbox","in &Absolutwerte",true 			'Umw. in Absolut aktivieren
		Promillewerte = true
	end if
	'++++++++++++++++++++++++++++++++++
next

RahmenAktuell = ZeileNeu
FF_SetProgressText 0,1,""

End Sub
'------------------------------------------------------------------------
Sub Vergr_Info (nurInfo)
'Vergrerungsinfo ermitteln (nurInfo = true) und ggf. Beschnitt (nurInfo = false)
Dim Rahmenzeilen,Rahmen,Wert
Dim Vli,Vob,Vre,Vun
Rahm_Wert = 1	'Pixelwerte

Rahmenzeilen = split(RahmenAktuell,vbNewLine)
for each Rahmen in Rahmenzeilen
	if Rahmen = "" then exit for
	if instr(Rahmen,"Bild um Farbe erweitern") > 0 then
		Wert = split(Rahmen,",")
		if Wert(1) = 1 then			'Promillewerte umrechnen in Pixel
			for n = 2 to 5
				Wert(n) = round(Wert(n) * Originalreferenz)
			next
		else
			Rahm_Wert = 2			'Absolutwerte
		end if
		Vli = Vli + Wert(2) * 1		'links
		Vob = Vob + Wert(3) * 1		'oben
		Vre = Vre + Wert(4) * 1		'rechts
		Vun = Vun + Wert(5) * 1		'unten
	end if
next

if not (Vli > 0 or Vob > 0 or Vre > 0 or Vun > 0) then Rahm_Wert = 0
if nurInfo then exit sub

call SV_Wahl
if Abbruch then
	Abbruch = false
	exit sub
end if
call Beschnitt (Vli + Vre, Vob + Vun)

End Sub
'------------------------------------------------------------------------
Sub SV_Wahl

'** Start Dialog Seitenverhltnis **
FF_AddDialog "Seitenverhltnis",111,75
FF_AddControl "Seitenverhltnis","Auswahl","GROUP",5,5,101,51
FF_AddControl "Seitenverhltnis","Seitenverhltnis","STATIC",14,14,42,11
FF_SetControlStyle "Seitenverhltnis","Seitenverhltnis",1
FF_AddControl "Seitenverhltnis","Breite zu Hhe","STATIC",14,22,42,11
FF_SetControlStyle "Seitenverhltnis","Breite zu Hhe",1
FF_AddControl "Seitenverhltnis","SV_Wert","COMBO",11,34,48,10
FF_AddControl "Seitenverhltnis","&Hinzu","BUTTON",65,13,33,11
FF_AddControl "Seitenverhltnis","&Standard","BUTTON",65,26,33,11
FF_AddControl "Seitenverhltnis","&Lschen","BUTTON",65,40,33,11
FF_AddControl "Seitenverhltnis","&Abbruch","BUTTON",16,60,33,11
FF_AddControl "Seitenverhltnis","&Beschnitt","BUTTON",65,60,33,11
'** End Dialog Seitenverhltnis **

call RegistryLesen ("SV")
FF_ActivateControl "Seitenverhltnis","&Beschnitt"

do
	Select Case FF_ShowDialog ("Seitenverhltnis")
	Case "&Hinzu"
		call Seitenverhaeltnis_Neu
	Case "&Standard"
		Antwort = msgbox ("Sollen die Standardwerte fr Seitenverhltnisse" & vbNewLine & _
				"wieder hergestellt werden?" & vbNewLine & vbNewLine & _
				"Alle bisherigen nderungen werden dabei verworfen!",vbYesNo or vbQuestion, "Seitenverhltnisse")
		if Antwort = vbYes then
			Seitenverhaeltnisse = StdSeitenverhaeltnisse
			SeitenverhWerte     = StdSeitenverhWerte
			FF_SetControl "Seitenverhltnis","SV_Wert",""
			BzuH_Array = split(Seitenverhaeltnisse,"/",-1)
			for n = 0 to ubound(BzuH_Array)-1
				FF_SetControl "Seitenverhltnis","SV_Wert",BzuH_Array(n)
			next
		end if 
	Case "&Lschen"
		SV_Wert = FF_GetControl ("Seitenverhltnis","SV_Wert")
		Antwort = msgbox ("Soll das Seitenverhltnis " & SV_Wert & " wirklich gelscht werden?",vbYesNo or vbQuestion, "Seitenverhltnis")
		if Antwort = vbYes then
			BzuH_Array = split(Seitenverhaeltnisse,"/",-1)
			BzuH_Werte = split(SeitenverhWerte,"/",-1)
			Seitenverhaeltnisse = ""
			SeitenverhWerte = ""
			Msg = ""	
			for n = 0 to ubound(BzuH_Array)-1
				if BzuH_Array(n) <> SV_Wert then
					Seitenverhaeltnisse = Seitenverhaeltnisse & BzuH_Array(n) & "/"
					SeitenverhWerte = SeitenverhWerte & BzuH_Werte(n) & "/"
				end if
			next
			FF_SetControl "Seitenverhltnis","SV_Wert",""
			BzuH_Array = split(Seitenverhaeltnisse,"/",-1)
			for n = 0 to ubound(BzuH_Array)-1
				FF_SetControl "Seitenverhltnis","SV_Wert",BzuH_Array(n)
			next
		end if
	Case "&Beschnitt"
		SV_Wert = FF_GetControl ("Seitenverhltnis","SV_Wert")
		if SV_Wert = "Original" then
			SV_Zahl = round(OrigBreite/OrigHoehe,2)
		else
			for n = 0 to ubound(BzuH_Array) -1
				if BzuH_Array(n) = SV_Wert then
					SV_Zahl = BzuH_Werte(n) * 1
					exit for
				end if
			next
		end if
		exit do
	Case "CANCEL", "&Abbruch"
		Abbruch = true
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben ("SV")
FF_CloseDialog ("Seitenverhltnis")

End Sub
'------------------------------------------------------------------------
Sub Seitenverhaeltnis_Neu
'Neues Seitenverhltnis definieren

'** Start Dialog Seitenverhltnis Bearbeiten **
FF_AddDialog "Seitenverhltnis Bearbeiten",110,65
FF_AddControl "Seitenverhltnis Bearbeiten","Benennung","STATIC",9,7,33,11
FF_AddControl "Seitenverhltnis Bearbeiten","Wert B/H","STATIC",60,7,33,11
FF_AddControl "Seitenverhltnis Bearbeiten","SVNeuB","SLEDIT",8,19,42,10
FF_SetControlStyle "Seitenverhltnis Bearbeiten","SVNeuB",1
FF_AddControl "Seitenverhltnis Bearbeiten","SVNeuW","SLEDIT",59,19,41,10
FF_SetControlStyle "Seitenverhltnis Bearbeiten","SVNeuW",1
FF_AddControl "Seitenverhltnis Bearbeiten","&Abbrechen","BUTTON",8,41,41,11
FF_AddControl "Seitenverhltnis Bearbeiten","&bernehmen","BUTTON",59,41,41,11
'** End Dialog Seitenverhltnis Bearbeiten **

BzuH_Array = split(Seitenverhaeltnisse,"/",-1)
BzuH_Werte = split(SeitenverhWerte,"/",-1)
SV_Wert = FF_GetControl ("Seitenverhltnis","SV_Wert")
for n = 0 to ubound(BzuH_Array)-1
	if BzuH_Array(n) = SV_Wert then 
		SV_Zahl = BzuH_Werte(n)
		exit for
	end if
next
FF_SetControl "Seitenverhltnis Bearbeiten","SVNeuB",SV_Wert
FF_SetControl "Seitenverhltnis Bearbeiten","SVNeuW",SV_Zahl
FF_ActivateControl "Seitenverhltnis Bearbeiten","SVNeuB"

Dim NeuBez, NeuWert
do
	Select Case FF_ShowDialog ("Seitenverhltnis Bearbeiten")
	Case "&bernehmen"
		NeuBez = FF_GetControl ("Seitenverhltnis Bearbeiten","SVNeuB")
		if NeuBez <> "" and instr(Seitenverhaeltnisse,"/" & NeuBez & "/") = 0 then
			NeuWert = FF_GetControl ("Seitenverhltnis Bearbeiten","SVNeuW")

			if  IsNumeric(NeuWert) then
				NeuWert = round(NeuWert,3)
				Seitenverhaeltnisse = Seitenverhaeltnisse & NeuBez & "/"
				SeitenverhWerte = SeitenverhWerte & NeuWert & "/"
				FF_SetControl "Seitenverhltnis","SV_Wert",NeuBez
				FF_SetControl "Seitenverhltnis","SV_Wert",NeuBez				
				exit do
			else
				WshShell.Popup "Der Wert B/H ist ungltig!",,"Neu eingeben!",vbExclamation
			end if
		else
			if NeuBez = "" then 
				msg = "Die Benennung fehlt!"
			else
				msg = "Der Wert B/H existiert bereits!" & vbNewLine & _
					  "Wenn er bearbeitet werden soll, muss er vorher gelscht werden."
			end if
			WshShell.Popup msg,,"Neu eingeben!",vbExclamation
		end if
	Case "CANCEL", "&Abbrechen"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Seitenverhltnis Bearbeiten")	

End Sub
'------------------------------------------------------------------------
Sub Beschnitt (VBreite,VHoehe)
Dim SollBreite,SollHoehe,SParameter,AntwortMD
Dim BeschnittOK : BeschnittOK = false

'Ermittlung von Sollbreite und Sollhhe
SollBreite = OrigBreite
SollHoehe  = (OrigBreite + VBreite) / SV_Zahl - VHoehe
if SollHoehe > OrigHoehe then
	SollHoehe = OrigHoehe
	SollBreite = (OrigHoehe + VHoehe) * SV_Zahl - VBreite
end if

SollBreite = round(SollBreite)
SollHoehe = round(SollHoehe)
msg = ""

'Beschnitt
if OrigBreite > OrigHoehe and SollBreite > SollHoehe or OrigBreite <= OrigHoehe and SollBreite <= SollHoehe then
	SParameter = "Values=0,0," & cstr(SollBreite) & "," & cstr(SollHoehe) & "," & OrigBreite & "," & OrigHoehe & "," & Markierung & ",1"
else
	SParameter = "Values=0,0," & cstr(SollBreite) & "," & cstr(SollHoehe) & "," & OrigHoehe & "," & OrigBreite & "," & Markierung & ",1"
	if OrigBreite > OrigHoehe then msg = "Ein querformatiges Bild soll hochformatig beschnitten werden."
	if OrigBreite = OrigHoehe then msg = "Ein quadratisches Bild soll hochformatig beschnitten werden."
	if OrigBreite < OrigHoehe then msg = "Ein hochformatiges Bild soll querformatig beschnitten werden."
	msg = msg & vbNewLine & "Daher muss im folgenden Dialog Taste 'Hoch/Quer' bettigt werden!" & vbNewLine & vbNewLine
end if

if not SchnittTextSperre then
	Select Case Rahm_Wert
		Case 0		'keine Vergrerung durch Rahmung
			msg = msg & "Da keine Vergerung des Bildes durch die" & vbNewLine & _
						"Rahmung erfolgt,darf der Ausschnitt im" & vbNewLine & _
						"Schnitt-Dialog proportional verkleinert" & vbNewLine & _
						"werden."
		Case 1		'nur Promillewerte
			msg = msg & "Da die Vergrerungselemente des gewhlten" & vbNewLine & _
						"Rahmen nur Promillewerte enthalten, darf der" & vbNewLine & _
						"Ausschnitt im Schnitt-Dialog proportional" & vbNewLine & _
						"verkleinert werden."
		Case 2		'auch Absolutwerte
			msg = msg & "Da die Vergrerungselemente des gewhlten" & vbNewLine & _
						"Rahmen Absolutwerte enthalten, darf der" & vbNewLine & _
						"Ausschnitt im Schnitt-Dialog nicht ver-" & vbNewLine & _
						"kleinert werden. Der Schnittrahmen darf" & vbNewLine & _
						"lediglich verschoben werden." & vbNewLine & _
						"Anderenfalls wird das nach der Rahmung" & vbNewLine & _
						"gewnschte Format nicht erreicht."
	End select
end if

if len(msg) > 0 then WshShell.Popup msg,,"Unbedingt beachten!",vbInformation

if PopZaehler > 0 then FF_PopImage() : PopZaehler = PopZaehler - 1
if PopZaehler > 0 then FF_PopImage() : PopZaehler = PopZaehler - 1

FF_SetParam SParameter
AntwortMD = FF_MultiDialog ("MultiCanvas",2)
if AntwortMD < 0 then
	msgbox "Das Bild wurde nicht beschnitten!",vbExclamation,"Abbruch"
	Abbruch = true
else
	BeschnittOK = true
	Abbruch = false
end if

if BeschnittOK then
	call Faktorenbestimmung
	SkalierwertSt = 1 : SkalierwertPo = 1 : FaktorSV = 1
	Anzahl = 0
	call RahmenErstellung (RahmenAktuell)
	if not flagSelektierteBilder then FF_Reload() : Abbruch = true
	exit sub
end if

if not BeschnittOK then
	'Kein Rahmen, daher Vorschau wieder herrichten
	OrigBreite = FF_GetImageWidth()	'Originalbreite
	OrigHoehe = FF_GetImageHeight()	'Originalhhe
	
	call Faktorenbestimmung
	FF_PushImage() : PopZaehler = PopZaehler + 1
	
	'Vorschau mit verkleinertem Bild
	if boolVorschauVerkleinert then
		FF_HQScale MaxLaenge,MaxLaenge, true
		Breite=FF_GetImageWidth()		'Abmessungen der Verkleinerung
		Hoehe =FF_GetImageHeight()
		Referenz = MaxLaenge/1000 
		FaktorSV = MaxLaenge/LangeSeite 'Absolutwerte in Wertermittlung damit multiplizieren
		FF_PushImage() : PopZaehler = PopZaehler + 1
		call Vorschau
	else
		FF_PushImage() : PopZaehler = PopZaehler + 1
		FaktorSV = 1
	end if
end if

End Sub
'------------------------------------------------------------------------
'########################## Rahmen erzeugen #############################
'------------------------------------------------------------------------
Sub WertErmittlung
Dim MaxWerteanzahl

WertArray = split(RahmenArt,",")
if WertArray(0) = "Text einblenden" then 
	TextFont = WertArray(16)
	MaxWerteanzahl = 16
else
	MaxWerteanzahl = 15
end if

if ubound(WertArray) > MaxWerteanzahl then
	if Rahmentest then
		RahmenZeileText = Rahmenart
		Abbruch = true
		exit sub
	else
		msgbox "Fehler in der Werteanzahl!",vbCritical,"Hinweis"
	end if
end if

if WertArray(1) = "0" then				'Strke Absolutwerte
	'Strke = Pixel
	STlinks = WertArray(2) * SkalierwertSt * FaktorSV
	SToben  = WertArray(3) * SkalierwertSt * FaktorSV
	STrechts= WertArray(4) * SkalierwertSt * FaktorSV
	STunten = WertArray(5) * SkalierwertSt * FaktorSV
elseif WertArray(1) = "1" then			'Strke Promillewerte
	'Strke = Promille
	STlinks = WertArray(2) * SkalierwertSt * Referenz
	SToben  = WertArray(3) * SkalierwertSt * Referenz
	STrechts= WertArray(4) * SkalierwertSt * Referenz
	STunten = WertArray(5) * SkalierwertSt * Referenz
else
	if Rahmentest then
		RahmenZeileText = Rahmenart
		Abbruch = true
		exit sub
	else
		msgbox "Fehler in der Definition Absolut-/Promillewerte!",vbCritical,"Hinweis"
	end if
end if

if STlinks  > 0 and STlinks  < 1 then STlinks  = 1 else STlinks  = round(STlinks )
if SToben   > 0 and SToben   < 1 then SToben   = 1 else SToben   = round(SToben  )
if STrechts > 0 and STrechts < 1 then STrechts = 1 else STrechts = round(STrechts)
if STunten  > 0 and STunten  < 1 then STunten  = 1 else STunten  = round(STunten )

if WertArray(6) = "0" then				'Position Absolutwerte
	'Position = Pixel
	POlinks = WertArray(7)  * SkalierwertPo * FaktorSV
	POoben  = WertArray(8)  * SkalierwertPo * FaktorSV
	POrechts= WertArray(9)  * SkalierwertPo * FaktorSV
	POunten = WertArray(10) * SkalierwertPo * FaktorSV
elseif WertArray(6) = "1" then			'Position Promillewerte
	'Position = Promille
	POlinks = WertArray(7)  * SkalierwertPo * Referenz
	POoben  = WertArray(8)  * SkalierwertPo * Referenz
	POrechts= WertArray(9)  * SkalierwertPo * Referenz
	POunten = WertArray(10) * SkalierwertPo * Referenz
else
	if Rahmentest then
		RahmenZeileText = Rahmenart
		Abbruch = true
		exit sub
	else
		msgbox "Fehler in der Definition Absolut-/Promillewerte!",vbCritical,"Hinweis"
	end if
end if

if POlinks  > 0 and POlinks  < 1 then POlinks  = 1 else POlinks  = round(POlinks )
if POoben   > 0 and POoben   < 1 then POoben   = 1 else POoben   = round(POoben  )
if POrechts > 0 and POrechts < 1 then POrechts = 1 else POrechts = round(POrechts)
if POunten  > 0 and POunten  < 1 then POunten  = 1 else POunten  = round(POunten )

Farbe = split(WertArray(11)," ")		'Rahmenfarbe
RRahmFarbe = Farbe(0) * 1
GRahmFarbe = Farbe(1) * 1
BRahmFarbe = Farbe(2) * 1

Farbe = split(WertArray(12)," ")		'Verlaufsfarbe
RVerlFarbe = Farbe(0) * 1
GVerlFarbe = Farbe(1) * 1
BVerlFarbe = Farbe(2) * 1

RegDeck  = WertArray(13) * 1			'Regler Deckung (transp)
RegWeich = WertArray(14) * 1			'Regler Weich (smooth)
RegEffekt= WertArray(15) * 1			'Regler Effekt

End Sub
'------------------------------------------------------------------------
Function LIMIT(c)

if c < 0 then c = 0
if c > 255 then c = 255

End Function
'------------------------------------------------------------------------
Sub CreateMask							'Maske der Rahmeneinstellung erzeugen
Dim BreiteAktuell, HoeheAktuell

BreiteAktuell=FF_GetImageWidth()	'Breite
HoeheAktuell =FF_GetImageHeight()	'Hoehe

call FF_SetArea(0,0,0,0,false,0,RegWeich * 64 / 255)

call FF_AreaFillRect(POlinks,POoben,POlinks + STlinks,HoeheAktuell - POunten,RegDeck)	'links
call FF_AreaFillRect(POlinks,POoben,BreiteAktuell - POrechts,Pooben + SToben,RegDeck)	'oben
call FF_AreaFillRect(POlinks,HoeheAktuell - POunten - STunten,BreiteAktuell - _
					 POrechts,HoeheAktuell - POunten,RegDeck)							'unten
call FF_AreaFillRect(BreiteAktuell - POrechts - STrechts,POoben,BreiteAktuell - _
					 POrechts,HoeheAktuell - POunten,RegDeck)							'rechts

'					 POrechts,HoeheAktuell - POunten - STunten,RegDeck)					'rechts bis 16.05.2102

End Sub
'------------------------------------------------------------------------
Sub Aufruf_Rahmenart

select case WertArray(0)				'Rahmenart
	case "Bild um Farbe erweitern"
		call ExtendCanvas
	case "Rahmenfarbe einzeichnen"
		call DrawBorder
	case "Unschrfe"
		call Blur
	case "Farbsttigung"
		call Saturation
	case "Helligkeit"
		call Brightness
	case "Kontrast"
		call Contrast
	case "Verlauf"
		call Smooth
	case "3D-Verlauf"
		call Smooth3D
	case "Schrgschnitt"
		call BevelCut
	case "Text einblenden"
		call DrawText
case else
	if Rahmentest then
		RahmenZeileText = Rahmenart
		Abbruch = true
	else
		msgbox "Fehler im Aufruf der Rahmenart!",vbCritical,"Hinweis"
	end if
end select

End Sub
'------------------------------------------------------------------------
Function ExtendCanvas 			'Bild um Farbe erweitern
Dim RegWeichTmp

call FF_SetArea(0,0,0,0,false,0,255)
call FF_ExtendCanvas(STlinks,STrechts,SToben,STunten,RRahmFarbe,GRahmFarbe,BRahmFarbe)

if RegDeck <> 0 and RegWeich <> 0 then
	call FF_SetArea(STlinks,SToben,Breite,Hoehe,true,RegDeck,RegWeich * 64 / 255)
	if RegWeich > 32 then RegWeichTmp = 32 else RegWeichTmp = RegWeich
	call FF_Blur(RegWeichTmp)
	call FF_SetArea(0,0,0,0,false,0,0)
end if

End Function
'------------------------------------------------------------------------
Function DrawBorder				'Rahmenfarbe einzeichnen

call CreateMask
call FF_WhiteBalance(-255,-255,-255)
call FF_WhiteBalance(RRahmFarbe,GRahmFarbe,BRahmFarbe)
	
End Function
'------------------------------------------------------------------------
Function Blur					'Unschrfe

call CreateMask
call FF_Blur(RegEffekt * 31 / 255 + 1)

End Function
'------------------------------------------------------------------------
Function Saturation				'Farbsttigung

call CreateMask
call FF_Saturation(RegEffekt / 128)

End Function
'------------------------------------------------------------------------
Function Brightness				'Helligkeit
Dim diff

diff = RegEffekt - 128
call CreateMask
call FF_WhiteBalance(diff,diff,diff)
	
End Function
'------------------------------------------------------------------------
Function Contrast				'Kontrast
Dim diff

diff = RegEffekt / 128
call CreateMask
call FF_AdjustRGB(diff,diff,diff)

if RegEffekt < 128 then
	diff = -(RegEffekt - 128)
	call FF_WhiteBalance(diff,diff,diff)
end if

End Function
'------------------------------------------------------------------------
Function Smooth					'Verlauf
Dim rdiff,gdiff,bdiff
Dim lp,tp,rp,bp
Dim n,max,r,g,b,co
Dim left,right,top,bottom

left = 0 : right = 0 : top = 0 : bottom = 0

rdiff = RVerlFarbe - RRahmFarbe
gdiff = GVerlFarbe - GRahmFarbe
bdiff = BVerlFarbe - BRahmFarbe

lp = POlinks + STlinks -1
tp = POoben + SToben-1
rp = FF_GetImageWidth - POrechts - STrechts
bp = FF_GetImageHeight - POunten - STunten

if STlinks > STrechts then max = STlinks else max = STrechts
if SToben > max then max = SToben
if STunten > max then max = STunten

for n = 0 to max - 1
	r = round(RRahmFarbe + rdiff * n / max)
	LIMIT r
	g = round(GRahmFarbe + gdiff * n / max)
	LIMIT g	
	b = round(BRahmFarbe + bdiff * n / max)
	LIMIT b
	
	co = b * (2^16) + g * (2^8) + r

	left = left + STlinks / max
	right = right + STrechts / max
	top = top + SToben / max
	bottom = bottom + STunten / max

	if left >=1 then
		call FF_VLine(tp,bp,lp,co)
		lp = lp - 1 : left = left -1
	end if

	if right >= 1 then
		call FF_VLine(tp,bp,rp,co)
		rp = rp +1 : right = right -1
	end if
	if top >= 1 then
		call FF_HLine(lp+1,rp,tp,co)
		tp = tp -1 : top = top -1
	end if
	if bottom >= 1 then
		call FF_HLine(lp+1,rp,bp,co)
		bp = bp +1 : bottom = bottom - 1
	end if
next

End Function
'------------------------------------------------------------------------
Function Smooth3D				'3D-Verlauf
Dim rdiff,gdiff,bdiff,rdd,gdd,bdd
Dim lp,tp,rp,bp
Dim n,i,max,r,g,b,co1,co2
Dim left,right,top,bottom

left = 0 : right = 0 : top = 0 : bottom = 0

rdiff = RVerlFarbe - RRahmFarbe : rdd = rdiff/2
gdiff = GVerlFarbe - GRahmFarbe : gdd = gdiff/2
bdiff = BVerlFarbe - BRahmFarbe : bdd = bdiff/2

lp = POlinks + STlinks -1 : tp = POoben + SToben-1
rp = FF_GetImageWidth() - POrechts - STrechts
bp = FF_GetImageHeight()- POoben - SToben

if STlinks > STrechts then max = STlinks else max = STrechts
if SToben > max then max = SToben
if STunten > max then max = STunten

for n = 0 to max - 1
	r = round(RRahmFarbe + rdd - rdiff * n / max) :	LIMIT r
	g = round(GRahmFarbe + gdd - gdiff * n / max) :	LIMIT g	
	b = round(BRahmFarbe + bdd - bdiff * n / max) :	LIMIT b
	co1 = b * (2^16) + g * (2^8) + r
	
	r = round(RRahmFarbe - rdd + rdiff * n / max) :	LIMIT r
	g = round(GRahmFarbe - gdd + gdiff * n / max) :	LIMIT g	
	b = round(BRahmFarbe - bdd + bdiff * n / max) :	LIMIT b
	co2 = b * (2^16) + g * (2^8) + r	

	left = (left + STlinks) / max
	right = (right + STrechts) / max
	top = (top + SToben) / max
	bottom = (bottom + STunten) / max

	if left >=1 then
		call FF_VLine(tp,bp,lp,co1)
		lp = lp - 1 : left = left -1
	end if

	if right >= 1 then
		call FF_VLine(tp,bp,rp,co2)
		rp = rp +1 : right = right -1
	end if
	
	if top >= 1 then
		call FF_HLine(lp+1,rp,tp,co1)
		tp = tp -1 : top = top -1
	end if
	
	if bottom >= 1 then
		call FF_HLine(lp+1,rp,bp,co2)
		bp = bp +1 : bottom = bottom - 1
	end if
next

End Function
'------------------------------------------------------------------------
Function BevelCut			'Schrgschnitt
Dim r,g,b,co1,co2,co3,co4
Dim lp,tp,rp,bp
Dim n,i,max
Dim left,right,top,bottom

left = 0 : right = 0 : top = 0 : bottom = 0

r = RRahmFarbe
g = GRahmFarbe
b = BRahmFarbe
co1 = b * (2^16) + g * (2^8) + r

r = round(RRahmFarbe - (128 - RegEffekt)/2) : LIMIT r
g = round(GRahmFarbe - (128 - RegEffekt)/2) : LIMIT g
b = round(BRahmFarbe - (128 - RegEffekt)/2) : LIMIT b
co2 = b * (2^16) + g * (2^8) + r

r = round(RRahmFarbe - (128 - RegEffekt)) : LIMIT r
g = round(GRahmFarbe - (128 - RegEffekt)) : LIMIT g
b = round(BRahmFarbe - (128 - RegEffekt)) : LIMIT b
co3 = b * (2^16) + g * (2^8) + r

r = round(RRahmFarbe - (128 - RegEffekt)*2) : LIMIT r
g = round(GRahmFarbe - (128 - RegEffekt)*2) : LIMIT g
b = round(BRahmFarbe - (128 - RegEffekt)*2) : LIMIT b
co4 = b * (2^16) + g * (2^8) + r

left = 0 : right = 0 : top = 0 : bottom = 0

lp = POlinks + STlinks -1 : tp = POoben + SToben-1
rp = FF_GetImageWidth() - POrechts - STrechts
bp = FF_GetImageHeight()- POoben - SToben

if STlinks > STrechts then max = STlinks else max = STrechts
if SToben > max then max = SToben
if STunten > max then max = STunten

for n = 0 to max - 1
	left = (left + STlinks) / max
	right = (right + STrechts) / max
	top = (top + SToben) / max
	bottom = (bottom + STunten) / max

	if left >=1 then
		call FF_VLine(tp,bp,lp,co3)
		lp = lp - 1 : left = left -1
	end if

	if right >= 1 then
		call FF_VLine(tp,bp,rp,co2)
		rp = rp +1 : right = right -1
	end if
	
	if top >= 1 then
		call FF_HLine(lp+1,rp,tp,co4)
		tp = tp -1 : top = top -1
	end if
	
	if bottom >= 1 then
		call FF_HLine(lp+1,rp,bp,co1)
		bp = bp +1 : bottom = bottom - 1
	end if
next

End Function
'------------------------------------------------------------------------
Function DrawText				'Text einblenden
Dim r,g,b,w,h,text,co1,ori,wei

if TextFont = "" then exit Function

w = FF_GetImageWidth() : h = FF_GetImageHeight()
r = RRahmFarbe
g = GRahmFarbe
b = BRahmFarbe
co1 = b * (2^16) + g * (2^8) + r
text = split(TextFont,"|")

call FF_SetArea(0,0,0,0,false,0,RegWeich * 64 / 255)
call FF_AreaFillRect(0,0,w,h,RegDeck)

ori = SToben
	do while ori < 0
		ori = ori + 3600
	loop
	do while ori > 3600
		ori = ori - 3600
	loop
wei = STrechts
	if wei < 0 then wei = 0
	if wei > 1000 then wei = 1000

call FF_TextAlign(30)
call FF_DrawText(text(0),POlinks,POoben,STlinks,ori,wei,SToben,false,text(1),co1)
'Msgbox text(0) & "," & POlinks & "," & POoben & "," & STlinks & "," & ori & "," & wei & "," & SToben & "," & "false" & "," & text(1) & "," & co1

if text(0) = "vorher Bild kopieren; danach einfgen" then flag_Copy = true

End Function
'------------------------------------------------------------------------
Sub BildCopy
'Kopieren des Originals in das gerahmte Bild
'weil im Rahmentext steht: "vorher Bild kopieren; danach einfgen"
Dim Breite,Hoehe,OBild

Breite=FF_GetImageWidth()
Hoehe =FF_GetImageHeight()	
if flagSelektierteBilder then OBild = OriginalBild else OBild = FF_GetImageName(-1)
'Msgbox OBild & vbNewLine & OrigBreite & " x " & OrigHoehe & vbNewLine & "Neu: " & Breite & " x " & Hoehe
FF_PushImage
FF_LoadImage OBild
FF_Miximage (Hoehe-OrigHoehe)/2,(Breite-OrigBreite)/2,OrigBreite,OrigHoehe,255
FF_PopImage

End Sub
'------------------------------------------------------------------------
'########################### Kurzbeschreibung ###########################
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim FBreite	: FBreite = LaengeMax * 2.3
const FHoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",FBreite,FHoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,FBreite,FHoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",FBreite/2-15,FHoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if Err.Number = 53 then
	 WshShell.Popup "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",,"Meldung",vbExclamation
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
'########################################################################
'------------------------------------------------------------------------
Sub RegistryLesen (Kennung)
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_MFDL_Toolbox

select case Kennung
case "SV"	'### Seitenverhltnisse

	Seitenverhaeltnisse = FF_GetProfile ("FF_MFDL_Toolbox","StdSeitenverhaeltnisse")
	SeitenverhWerte     = FF_GetProfile ("FF_MFDL_Toolbox","StdSeitenverhWerte")
	SV_Wert 			= FF_GetProfile ("FF_MFDL_Toolbox","SV_Wert")

	if Seitenverhaeltnisse 	= "" then					'noch keine Werte eingetragen
		Seitenverhaeltnisse = StdSeitenverhaeltnisse
		SeitenverhWerte     = StdSeitenverhWerte
	end if

	'Werte eintragen
	BzuH_Array = split(Seitenverhaeltnisse,"/",-1)		'Seitenverhltnisse
	for n = 0 to ubound(BzuH_Array)-1
		FF_SetControl "Seitenverhltnis","SV_Wert",BzuH_Array(n)
	next
	
	BzuH_Werte = split(SeitenverhWerte,"/",-1)

	if SV_Wert <> "" then FF_SetControl "Seitenverhltnis","SV_Wert",SV_Wert
	
case "SP"	'### Speicherparameter
	'Werte auslesen
	boolSuffix	= FF_GetProfile ("FF_MFDL_Toolbox","boolSuffix")
	Zusatz 		= FF_GetProfile ("FF_MFDL_Toolbox","Zusatz")
	quality 	= FF_GetProfile ("FF_MFDL_Toolbox","quality")
	
	if boolSuffix 	= "" then
		boolSuffix 	= 1
		Zusatz 		= "_MFDL"
		quality		= 0
	end if
	
	'Werte eintragen
	if boolSuffix = 1 then
		FF_SetControl "Speicherparameter","boolSuffix",1
		if Zusatz = "" then Zusatz = "_MFDL"
	else
		FF_SetControl "Speicherparameter","boolPraefix",1
		if Zusatz = "" then Zusatz = "MFDL_"
	end if
	FF_SetControl "Speicherparameter","Zusatz",Zusatz
	FF_SetControl "Speicherparameter","quality",quality
	
case "TB"	'### Toolbox
	'Werte auslesen
	ListeAktuell  = FF_GetProfile ("FF_MFDL_Toolbox","ListeAktuell")
	RahmenAuswahl = FF_GetProfile ("FF_MFDL_Toolbox","RahmenAuswahl")

	'Werte eintragen
	if ListeAktuell <> "" then FF_SetControl "MFDL-Toolbox","Listenauswahl",ListeAktuell
	if RahmenAuswahl <> "" then FF_SetControl "MFDL-Toolbox","Rahmennamen",RahmenAuswahl

case else
end select

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben (Kennung)
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_MFDL_Toolbox

select case Kennung
case "SV"	'### Seitenverhltnisse und -Werte
	FF_WriteProfile "FF_MFDL_Toolbox","StdSeitenverhaeltnisse",Seitenverhaeltnisse
	FF_WriteProfile "FF_MFDL_Toolbox","StdSeitenverhWerte",SeitenverhWerte

	SV_Wert = FF_GetControl ("Seitenverhltnis","SV_Wert")	'benutztes Seitenverhltnis
	FF_WriteProfile "FF_MFDL_Toolbox","SV_Wert",SV_Wert
	
case "SP"	'### Speicherparameter
	boolSuffix = FF_GetControl ("Speicherparameter","boolSuffix") * 1
	FF_WriteProfile "FF_MFDL_Toolbox","boolSuffix",boolSuffix
	Zusatz = FF_GetControl ("Speicherparameter","Zusatz")
	FF_WriteProfile "FF_MFDL_Toolbox","Zusatz",Zusatz
	quality = FF_GetControl ("Speicherparameter","quality")
	FF_WriteProfile "FF_MFDL_Toolbox","quality",quality

case "TB"	'### Toolbox
	ListeAktuell = FF_GetControl ("MFDL-Toolbox","Listenauswahl")
	FF_WriteProfile "FF_MFDL_Toolbox","ListeAktuell",ListeAktuell
	RahmenAuswahl = FF_GetControl ("MFDL-Toolbox","Rahmennamen")
	FF_WriteProfile "FF_MFDL_Toolbox","RahmenAuswahl",RahmenAuswahl

case else
end select

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
const RegSchluessel = "\FF_MFDL_Toolbox\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte" & vbNewLine &_ 
			"nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

TempFile = FF_GetScriptPath & "\MeckiScript\MFDL_Toolbox"		'Ordner
if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration'" & vbNewLine & _
	   "ist das Skript " & Skriptname & vbNewLine & _
	   "mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
'======================================== neu ab Version 4.00 ===========
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+++ Rahmen in Liste Standard sortieren +++++++++++++++++++++++++++++++++
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Sub Sortieren_Standard
Dim SortText,tAnf,tEnd

tAnf = Timer

call Vorbereitung
if Abbruch then exit sub

Call QuickSort(0, UBound(NeuListenArray))

call Rekonstruktion
Ergebnis = join(NeuListenArray,BZ)

Set SortText = objFS.OpenTextFile(Rahmendatei,ForWriting, True)
SortText.Write Ergebnis
SortText.Close

tEnd = Timer
if ZeitTest then msgbox "Das Sortieren dauerte " & round(tEnd - tAnf,2) & " sec.",vbInformation,"Info"
msgbox "Es wurden " & Max +1 & " Rahmen sortiert.",vbInformation,"Info"
 
End Sub
'-------------------------------------------------------------------------
Sub Vorbereitung
Dim RahmenText,Text,n,UL,ULn

if not objFS.FileExists(Rahmendatei) then
	msgbox "Die Rahmendatei" & vbNewLine & Rahmendatei & vbNewLine & "existiert nicht!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

Set RahmenText = objFS.OpenTextFile(Rahmendatei, ForReading)
Text = RahmenText.ReadAll
RahmenText.Close

'### Kontrolle der Rahmendatei
if len(Text) = 0 or instr(Text,"#") = 0 then
	msgbox "Es sind keine Rahmen vorhanden!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

if instr(Text,EZ) > 0 then
	msgbox "Der Rahmentext beinhaltet das Zeichen " & EZ & vbNewLine & _
		"was nicht erlaubt ist!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

if instr(Text,TZ) > 0 then
	msgbox "Der Rahmentext beinhaltet das Zeichen " & TZ & vbNewLine & _
		"was nicht erlaubt ist!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub
end if

'### Sortieren beginnen
Text = mid(Replace(Text,vbNewLine,EZ),2)		'vbNewline ersetzen durch Konstante EZ
if right(Text,1) <> EZ then Text = Text & EZ	'sicher stellen, dass am Textende ein Zeilenwechsel steht
UrListenArray = split(Text,BZ) 					'Sicherung des Ursprungs in einem Array
Text = ucase(Text)								'Text in Grobuchstaben wandeln
NeuListenArray = split(Text,BZ)					'Texte zur Sortierung eintragen in ein Array 
Max = UBound(NeuListenArray)					'oberer Grenzwert der Arrays

'### Umlautkorrektur fr das erste Zeichen
for n = 0 to Max

	UL = left(NeuListenArray(n),1)
	if instr("",UL) > 0 then
		select case UL
			case "" : ULn = "Ae"
			case "" : ULn = "Oe"
			case "" : ULn = "Ue"
		case else
		end select
		NeuListenArray(n) = ULn & mid(NeuListenArray(n),2) & TZ & UL
	end if
next

End Sub
'------------------------------------------------------------------------
Sub Rekonstruktion
Dim n,pos,element,Rahmenarray

'### Rahmenliste lschen
FF_SetControl "MFDL-Toolbox","Rahmennamen",""

for n = 0 to Max
	'### Umlaute wieder zurck setzen
	pos = instr(NeuListenArray(n),TZ)
	if pos > 0 then
		NeuListenArray(n) = right(NeuListenArray(n),1) & mid(NeuListenArray(n),3,pos -3)
	end if
	
	'### ursprngliche Gro- und Kleinschreibung wieder herstellen
	for each element in UrListenArray
		if NeuListenArray(n) = ucase(element) then NeuListenArray(n) = element :	exit for
	next
	
	'### Zeilenumbrche wieder herstellen
	NeuListenArray(n) = Replace(NeuListenArray(n),EZ,vbNewLine)
	
	'### Neueintrag in Rahmenliste
	Rahmenarray = split(NeuListenArray(n),vbNewLine)
	FF_SetControl "MFDL-Toolbox","Rahmennamen",Rahmenarray(0)
next

NeuListenArray(0) = BZ & NeuListenArray(0)

End Sub
'------------------------------------------------------------------------
Sub QuickSort(ByVal LB, ByVal UB)
'### Sortieren des Arrays 'NeuListenArray' nach ASCII-Werten
Dim P1, P2, Ref, TEMP,FS
	
	FS = FS + 1
    P1 = LB
    P2 = UB
    Ref = NeuListenArray((P1 + P2) / 2)
    
    Do
        Do While NeuListenArray(P1) < Ref
            P1 = P1 + 1
        Loop
 
        Do While NeuListenArray(P2) > Ref
            P2 = P2 - 1
        Loop

        If P1 <= P2 Then
            TEMP = NeuListenArray(P1)
            NeuListenArray(P1) = NeuListenArray(P2)
            NeuListenArray(P2) = TEMP
           
            P1 = P1 + 1
            P2 = P2 - 1
        End If
    Loop Until P1 > P2

    If LB < P2 Then Call QuickSort(LB, P2)
    If P1 < UB Then Call QuickSort(P1, UB)

End Sub
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+++ Listenmanagement +++++++++++++++++++++++++++++++++++++++++++++++++++
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Sub ListenauswahlFuellen
'Listenauswahl mit Liste "Standard" und allen vorhandenen virtuellen Listen fllen
'und Rahmen in Standardliste eintragen

Dim Datei,Zeile

FF_SetControl "MFDL-Toolbox","Listenauswahl",""
FF_SetControl "MFDL-Toolbox","Listenauswahl","Standard"
if objFS.FileExists(Listendatei) then
	Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
	do Until Datei.AtEndOfStream
		Zeile = Datei.ReadLine
		if left(Zeile,1) = "#" then FF_SetControl "MFDL-Toolbox","Listenauswahl",mid(Zeile,2)
	loop
	Datei.Close
end if

ListeAktuell = "Standard"
call Rahmennamen_Liste			'Rahmennamen auslesen aus Rahmendatei MFDL.cfg
call NeuEintrag	("Standard")	'und Rahmen eintragen

FF_EnableControl "MFDL-Toolbox","Umbenennen",false
FF_EnableControl "MFDL-Toolbox","Lschen",false

End Sub
'-------------------------------------------------------------------------
Sub ListeNeu
'neue virtuelle Liste erstellen

Dim Datei,Zeile,ListenSumme

ListeAktuell = inputbox("Wie soll die neue Liste" & vbNewLine & _
						 "benannt werden?","Listenname","")
if ListeAktuell = "" then exit sub

if instr(ListeAktuell,"#") > 0 then
	msgbox "Der Listenname darf nicht das Zeichen # enthalten!",vbExclamation,"Hinweis"
	exit sub
end if

if objFS.FileExists(Listendatei) then
	Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
	do Until Datei.AtEndOfStream
		Zeile = Datei.ReadLine
		if left(Zeile,1) = "#" then 
			if ucase(Zeile) = "#" & ucase(ListeAktuell) then
				msgbox "Die Liste " & """" & mid(Zeile,2) & """" & _
		   			   " ist bereits angelegt!",vbExclamation,"Hinweis"
				exit sub
			end if
		end if
	loop
	Datei.Close
end if

Set Datei = objFS.OpenTextFile(Listendatei, ForAppending, True)
Datei.Write vbNewLine & "#" & ListeAktuell
Datei.Close

FF_SetControl "MFDL-Toolbox","Listenauswahl",ListeAktuell

call Rahmennamen_Liste				'Rahmennamen auslesen aus Rahmendatei
call NeuEintrag	("Standard")		'und eintragen
FF_SetControl "MFDL-Toolbox","Listenauswahl","Standard"

		if len(Rahmenauswahl) > 0 then
			FF_SetControl "MFDL-Toolbox","Rahmennamen",Rahmenauswahl
		end if

flagRahmenHinzu = 1
RahmenSumme = ""
call AusEinblenden
FF_EnableControl "MFDL-Toolbox","RahmenHinzu",true
FF_EnableControl "MFDL-Toolbox","Rahmen hinzufgen Ein/Aus",true
FF_SetControl "MFDL-Toolbox","RahmenHinzu",1
RahmenSumme = ""

FF_SetControl "MFDL-Toolbox","||","Rahmen kopieren in Liste " & """" & ListeAktuell & """"

End Sub
'-------------------------------------------------------------------------
Sub ListeAuslesen (RListe)
'aus Listendatei die Rahmen zur ausgewhlten virtuellen RListe auslesen

Dim Datei,Zeile,Gefunden : Gefunden = false
if flagRahmenHinzu = 0 then RahmenSumme = ""

Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
do Until Datei.AtEndOfStream
	Zeile = Datei.ReadLine
	if not Gefunden then
		if Zeile = "#" & RListe then Gefunden = true
	else
		if left(Zeile,1) = "#" then exit do
		if len(RahmenSumme) = 0 then
			RahmenSumme = Zeile
		else
			RahmenSumme = RahmenSumme & vbNewLine & Zeile
		end if
	end if
loop

Datei.Close

End Sub
'-------------------------------------------------------------------------
Sub ListeSchreiben (Anmerkung)
'RahmenSumme in Listendatei zur ausgewhlten Liste schreiben
'Anmerkung = Schreiben = Rahmen eintragen
'Anmerkung = Lschen = ganze Liste lschen

Dim Datei,Zeile,Teil1,Teil2,ListenName
Dim Teil1_OK : Teil1_OK = false
Dim Teil1_Ende : Teil1_Ende = false

Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
do Until Datei.AtEndOfStream
	Zeile = Datei.ReadLine
	if not Teil1_OK then
		if Zeile <> "#" & ListeAktuell then
			if len(Teil1) = 0 then
				Teil1 = Zeile
			else
				Teil1 = Teil1 & vbNewLine & Zeile
			end if
		else
			if len(Teil1) > 0 then ListenName = vbNewLine
			ListenName = ListenName & Zeile & vbNewLine
			Teil1_OK = true
		end if
	else
		if instr(Zeile,"#") > 0 then Teil1_Ende = true
		if Teil1_Ende then
			if len(Teil2) = 0 then
				Teil2 = Zeile
			else
				Teil2 = Teil2 & vbNewLine & Zeile
			end if
		end if
	end if
loop
Datei.Close

Set Datei = objFS.OpenTextFile(Listendatei, ForWriting, True)
Datei.Write Teil1
if Anmerkung = "Schreiben" then
	Datei.Write ListenName
	Datei.Write RahmenSumme	'alle Rahmen zur ausgewhlten Liste
end if
if len(Teil2) > 0 then Teil2 = vbNewLine & Teil2
Datei.Write Teil2
Datei.Close

End Sub
'-------------------------------------------------------------------------
Sub ListeLoeschen
'ausgewhlte virtuelle Liste wird komplett mit Rahmennamen gelscht

Antwort = msgbox("Soll die Liste " & """" & ListeAktuell & """" & vbNewLine & _
			     " wirklich gelscht werden?",vbYesNo + vbQuestion,"Sicherheitsabfrage")
if Antwort = vbNo then exit sub

'Gewhlte Liste aus Listendatei lschen
call ListeSchreiben ("Lschen")

'Listenauswahl lschen und neu einlesen
FF_SetControl "MFDL-Toolbox","Listenauswahl",""
call ListenauswahlFuellen
FF_SetControl "MFDL-Toolbox","||","Liste " & """" & "Standard" & """" & " ist aktiv"

End Sub
'-------------------------------------------------------------------------
Sub ListeUmbenennen
'virtuelle Liste umbenennen
'Zweideutigkeit bearbeitet

Dim ListenNameNeu,Datei,Zeile,DateiText

ListenNameNeu = inputbox("Welchen Namen soll die Liste " & """" & ListeAktuell & _
						 " bekommen?","Listenname",ListeAktuell)
if ListenNameNeu = "" then exit sub

if instr(ListenNameNeu,"#") > 0 then
	msgbox "Der Listenname darf nicht das Zeichen # enthalten!",vbExclamation,"Hinweis"
	exit sub
end if

if objFS.FileExists(Listendatei) then
	Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
	do Until Datei.AtEndOfStream
		Zeile = Datei.ReadLine
		if left(Zeile,1) = "#" then 
			if ucase(Zeile) = "#" & ucase(ListenNameNeu) then
				msgbox "Die Liste " & """" & mid(Zeile,2) & """" & _
		   			   " ist bereits angelegt!",vbExclamation,"Hinweis"
				exit sub
			end if
		end if
	loop
	Datei.Close
end if

'umbenennen
Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
DateiText = Datei.ReadAll
Datei.Close

DateiText = DateiText & vbNewLine
DateiText = replace(DateiText,"#" & ListeAktuell & vbNewLine,"#" & ListenNameNeu & vbNewLine)
DateiText = left(DateiText,len(DateiText) -2)

Set Datei = objFS.OpenTextFile(Listendatei, ForWriting, True)
Datei.Write DateiText
Datei.Close

'anzeigen
FF_SetControl "MFDL-Toolbox","Listenauswahl",""
FF_SetControl "MFDL-Toolbox","Listenauswahl","Standard"
if objFS.FileExists(Listendatei) then
	Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
	do Until Datei.AtEndOfStream
		Zeile = Datei.ReadLine
		if left(Zeile,1) = "#" then FF_SetControl "MFDL-Toolbox","Listenauswahl",mid(Zeile,2)
	loop
	Datei.Close
end if

ListeAktuell = ListenNameNeu
FF_SetControl "MFDL-Toolbox","Listenauswahl",ListeAktuell
FF_SetControl "MFDL-Toolbox","||","Liste " & """" & ListeAktuell & """" & " ist aktiv"

End Sub
'-------------------------------------------------------------------------
Sub RahmnenInListe
'Rahmen von der Standardliste in RahmenSumme eintragen

Dim RahmenErfasst

RahmenErfasst = FF_GetControl("MFDL-Toolbox","Rahmennamen")
if instr(vbNewLine & RahmenSumme & vbNewLine,vbNewLine & RahmenErfasst & vbNewLine) > 0 then
	msgbox "Der Rahmen " & """" & RahmenErfasst & """" & vbNewLine & _
		   "ist bereits Bestandteil der Liste " & """" & ListeAktuell & """" & ".",vbInformation,"Hinweis"
	exit sub
end if

WshShell.Popup "Der Rahmen " & """" & RahmenErfasst & """" & vbNewLine & _
			   "wird in Liste " & """" & ListeAktuell & """" & " eingefgt!",1,"Hinweis",vbInformation

if len(RahmenSumme) = 0 then
	RahmenSumme = RahmenErfasst
else
	RahmenSumme = RahmenSumme & vbNewLine & RahmenErfasst
end if

End Sub
'-------------------------------------------------------------------------
Sub RahmenHinzuEnde
'beenden des Hinzufgens von Rahmen

Dim Array,element

if len(RahmenSumme) > 0 then
	call ListeSchreiben ("Schreiben")
	
	FF_SetControl "MFDL-Toolbox","Listenauswahl",ListeAktuell
	FF_SetControl "MFDL-Toolbox","Rahmennamen",""
	
	call NeuEintrag (ListeAktuell)
	call Vorschau
else
	FF_SetControl "MFDL-Toolbox","||","Liste " & """" & "Standard" & """" & " ist aktiv"
	FF_EnableControl "MFDL-Toolbox","Umbenennen",false
	FF_EnableControl "MFDL-Toolbox","Lschen",false
end if

End Sub
'-------------------------------------------------------------------------
Sub RahmenUmbenennen_InAllenListen
'Umbenennen des Rahmens in allen virtuelln Listen
'Zweideutigkeit bearbeitet
Dim Datei

if not objFS.FileExists(Listendatei) then exit sub

on error resume next
Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
Rahmensumme	= Datei.ReadAll
Datei.Close
if err.number > 0 then exit sub
on error goto 0

Rahmensumme = vbNewLine & Rahmensumme & vbNewLine
Rahmensumme = replace(Rahmensumme,vbNewLine & Rahmenauswahl & vbNewLine,vbNewLine & RahmenNeu & vbNewLine)
Rahmensumme = mid(Rahmensumme,3)
Rahmensumme = left(Rahmensumme,len(Rahmensumme) -2)

Set Datei = objFS.OpenTextFile(Listendatei, ForWriting, True)
Datei.Write Rahmensumme
Datei.Close

End Sub
'-------------------------------------------------------------------------
Sub Loeschen_InAllenListen (RahmenGewaehlt)
'Lschen des Rahmens RahmenGewaehlt in allen virtuellen Listen
'Zweideutigkeit bearbeitet
Dim Datei

if not objFS.FileExists(Listendatei) then exit sub

Set Datei = objFS.OpenTextFile(Listendatei, ForReading, True)
on error resume next				'fr den Fall, dass die Datei leer ist
	Rahmensumme	= Datei.ReadAll
	Datei.Close
if Err.Number <> 0 then exit sub

Rahmensumme = vbNewLine & Rahmensumme & vbNewLine
Rahmensumme = replace(Rahmensumme,vbNewLine & RahmenGewaehlt & vbNewLine,vbNewline)
Rahmensumme = mid(Rahmensumme,3)
Rahmensumme = left(Rahmensumme,len(Rahmensumme) -2)

Set Datei = objFS.OpenTextFile(Listendatei, ForWriting, True)
Datei.Write Rahmensumme
Datei.Close

End Sub
'-------------------------------------------------------------------------
Sub Loeschen_InListe (RahmenGewaehlt)
'Lschen des Rahmens RahmenGewaehlt in der ausgewhlten ListeAktuell
'Zweideutigkeit bearbeitet
Dim Array,element

call ListeAuslesen (ListeAktuell)

Rahmensumme = vbNewLine & Rahmensumme & vbNewLine
Rahmensumme = replace(Rahmensumme,vbNewLine & RahmenGewaehlt & vbNewLine,vbNewLine)
Rahmensumme = mid(Rahmensumme,3)
if right(Rahmensumme,2) = vbNewLine then Rahmensumme = left(Rahmensumme,len(Rahmensumme) -2)

call ListeSchreiben ("Schreiben")

FF_SetControl "MFDL-Toolbox","Rahmennamen",""	'Rahmen neu eintragen
if len(Rahmensumme) = 0 then exit sub
Array = split(Rahmensumme,vbNewLine)
for each element in Array
	FF_SetControl "MFDL-Toolbox","Rahmennamen",element
next

AnzeigeZeile = Array(0)

End Sub
'-------------------------------------------------------------------------
Sub AusEinblenden

if flagRahmenHinzu = 1 then
	FF_EnableControl "MFDL-Toolbox","Listenauswahl",false
	FF_EnableControl "MFDL-Toolbox","Neu",false
	FF_EnableControl "MFDL-Toolbox","Umbenennen",false
	FF_EnableControl "MFDL-Toolbox","Lschen",false
	FF_EnableControl "MFDL-Toolbox","Hin&zu",true
	
	FF_EnableControl "MFDL-Toolbox","&Sortieren",false
	FF_EnableControl "MFDL-Toolbox","&Umbenennen",false
	FF_EnableControl "MFDL-Toolbox","&Lschen",false
	
	FF_EnableControl "MFDL-Toolbox","EinAus",false
	FF_EnableControl "MFDL-Toolbox","&Ein/Aus",false
else
	FF_EnableControl "MFDL-Toolbox","Listenauswahl",true
	FF_EnableControl "MFDL-Toolbox","Neu",true
	FF_EnableControl "MFDL-Toolbox","Umbenennen",true
	FF_EnableControl "MFDL-Toolbox","Lschen",true
	FF_EnableControl "MFDL-Toolbox","Hin&zu",false
	
	FF_EnableControl "MFDL-Toolbox","&Sortieren",true
	FF_EnableControl "MFDL-Toolbox","&Umbenennen",true
	FF_EnableControl "MFDL-Toolbox","&Lschen",true
	
	FF_EnableControl "MFDL-Toolbox","EinAus",true
	FF_EnableControl "MFDL-Toolbox","&Ein/Aus",true
end if

End Sub
'------------------------------------------------------------------------
Sub Duplikatstest_All
'alle Rahmen auf Duplikate prfen und ggf. lschen
Dim Datei,RahmenKomplett,UrDatenArray,DatenArray,element
Dim RahmenN,RahmnenK,RahmenDoppel,DatenDoppelArray,pos,n,m,Rgleich
Dim Rueckfrage : Rueckfrage = true
R_ungleich = 0 : Rgeloescht = 0

Set Datei = objFS.OpenTextFile(RahmenDatei, ForReading)
RahmenKomplett = Datei.ReadAll
Datei.Close
RahmenKomplett = mid(RahmenKomplett,2)

UrDatenArray = split(RahmenKomplett,"#")
DatenArray = split(RahmenKomplett,"#")

for n = 0 to ubound(UrDatenArray)
	pos = instr(UrDatenArray(n),vbNewLine)
	RahmenAuswahl = left(UrDatenArray(n),pos -1)
	RahmenAktuell = mid(UrDatenArray(n),pos +2)
	
	'### Duplikatstest
	Rgleich = 0
	for m = n +1 to ubound(DatenArray)
		pos = instr(DatenArray(m),vbNewLine)
		RahmenN = left(DatenArray(m),pos -1)
		RahmnenK = mid(DatenArray(m),pos +2)
		if RahmenN <> RahmenAuswahl and RahmnenK = RahmenAktuell then
			if Rgleich = 0 then
				RahmenDoppel = RahmenN
			else
				RahmenDoppel = RahmenDoppel & vbNewLine & RahmenN
			end if
			Rgleich = Rgleich +1
			R_ungleich = R_ungleich +1
		end if
	next
	
	if Rgleich > 0 then
		if Rueckfrage then
			Antwort = msgbox  ( "Zum Rahmen" & vbNewLine & "  " & RahmenAuswahl & vbNewLine & _
						"wurde(n) " & Rgleich & " Duplikat(e) gefunden:" & vbNewLine & vbNewLine & _
						RahmenDoppel & vbNewLine & vbNewLine & _
						"Sollen die Duplikate unwiderruflich gelscht werden?",vbQuestion + vbYesNoCancel,"Duplikate")
			if Antwort = vbYes then
				'### Duplikate lschen
				Rgeloescht = Rgeloescht + Rgleich
				DatenDoppelArray = split(RahmenDoppel,vbNewLine)
				for each element in DatenDoppelArray
					call Loeschen_Standard (element)
					call Loeschen_InAllenListen (element)
				next
				
				Antwort = msgbox  ( "Sollen alle weiteren entdeckten Duplikate" & vbNewLine & _
									"ohne weitere Rckfrage gelscht werden?",vbQuestion + vbYesNo,"Duplikate")
				if Antwort = vbYes then Rueckfrage = false
			end if
			
			if Antwort = vbCancel then
				msgbox "Die Duplikatssuche wird abgebrochen!",vbExclamation,"Duplikate"
				exit for
			end if
		else
			'### Duplikate lschen
			Rgeloescht = Rgeloescht + Rgleich
			DatenDoppelArray = split(RahmenDoppel,vbNewLine)
			for each element in DatenDoppelArray
				call Loeschen_Standard (element)
				call Loeschen_InAllenListen (element)
			next
		end if
	end if
next

'Suche beendet
if R_ungleich < 1 then
	msgbox "Es wurden keine Rahmenduplikate gefunden!",vbInformation,"Duplikatstest"
else
	msgbox "Es wurde(n) " & R_ungleich & " Duplikat(e) gefunden." & vbNewLine & _
		   "Davon wurde(n) " & Rgeloescht & " Duplikat(e) gelscht!",vbInformation,"Duplikatstest"
end if
Rahmenaktiv = "" : RahmenAuswahl = ""
call Vorschau

End Sub
'------------------------------------------------------------------------
Sub Duplikatstest
'Rahmen auf Duplikate prfen und ggf. lschen
Dim Datei,RahmenKomplett,DatenArray,element,RahmenN,RahmnenK,pos,n
Dim Rgleich : Rgleich = 0

Set Datei = objFS.OpenTextFile(RahmenDatei, ForReading)
RahmenKomplett = Datei.ReadAll
Datei.Close
RahmenKomplett = mid(RahmenKomplett,2)

DatenArray = split(RahmenKomplett,"#")

for n = 0 to ubound(DatenArray)
	pos = instr(DatenArray(n),vbNewLine)
	RahmenN = left(DatenArray(n),pos -1)
	RahmnenK = mid(DatenArray(n),pos +2)
	if RahmenN <> RahmenAuswahl and RahmnenK = RahmenAktuell then
		if Rgleich = 0 then
			RahmenKomplett = RahmenN
		else
			RahmenKomplett = RahmenKomplett & vbNewLine & RahmenN
		end if
		Rgleich = Rgleich +1
		R_ungleich = R_ungleich +1
	end if
next

if Rgleich < 1 then
	msgbox "Zum Rahmen" & vbNewLine & "  " & RahmenAuswahl & vbNewLine & "wurde kein Duplikat gefunden.",vbInformation,"Info"
	exit sub
else
	Antwort = msgbox  ( "Zum Rahmen" & vbNewLine & "  " & RahmenAuswahl & vbNewLine & _
						"wurde(n) " & Rgleich & " Duplikat(e) gefunden:" & vbNewLine & vbNewLine & _
						RahmenKomplett & vbNewLine & vbNewLine & _
						"Sollen die Duplikate unwiderruflich gelscht werden?",vbQuestion + vbYesNo,"Duplikate")
	if Antwort = vbNo then exit sub
	Rgeloescht = Rgeloescht + Rgleich
end if

'Duplikate lschen
DatenArray = split(RahmenKomplett,vbNewLine)
for each element in DatenArray
	call Loeschen_Standard (element)
	call Loeschen_InAllenListen (element)
next

'Duplikatssuche beendet
FF_SetControl "MFDL-Toolbox","Rahmennamen",RahmenAuswahl
msgbox "Die Duplikate wurden in der Rahmendatei gelscht und" & vbNewLine & _
	"aus den virtuellen Listen, soweit vorhanden, entfernt.",vbInformation,"Duplikate"
Rahmenaktiv = "" : RahmenAuswahl = ""
call Vorschau

End Sub
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+++ Rahmen in virtueller ListeAktuell sortieren ++++++++++++++++++++++++
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Sub Sortieren_Liste
Dim SortText,tAnf,tEnd,Ergebnis

tAnf = Timer

call Vorbereitung_Liste
if Abbruch then exit sub

Call QuickSort(0, UBound(NeuListenArray))

call Rekonstruktion_Liste
Rahmensumme = join(NeuListenArray,vbNewLine)

call ListeSchreiben ("Schreiben")

tEnd = Timer
if ZeitTest then msgbox "Das Sortieren dauerte " & round(tEnd - tAnf,2) & " sec.",vbInformation,"Info"
msgbox "Es wurden " & Max +1 & " Rahmen sortiert.",vbInformation,"Info"
 
End Sub
'-------------------------------------------------------------------------
Sub Vorbereitung_Liste
Dim RahmenText,Text,n,UL,ULn

call ListeAuslesen (ListeAktuell)
Text = Rahmensumme

'### Sortieren beginnen
UrListenArray = split(Text,vbNewline) 			'Sicherung des Ursprungs in einem Array
Text = ucase(Text)								'Text in Grobuchstaben wandeln
NeuListenArray = split(Text,vbNewLine)			'Texte zur Sortierung eintragen in ein Array 
Max = UBound(NeuListenArray)					'oberer Grenzwert der Arrays

'### Umlautkorrektur fr das erste Zeichen
for n = 0 to Max

	UL = left(NeuListenArray(n),1)
	if instr("",UL) > 0 then
		select case UL
			case "" : ULn = "Ae"
			case "" : ULn = "Oe"
			case "" : ULn = "Ue"
		case else
		end select
		NeuListenArray(n) = ULn & mid(NeuListenArray(n),2) & TZ & UL
	end if
next

End Sub
'------------------------------------------------------------------------
Sub Rekonstruktion_Liste
Dim n,pos,element,Rahmenarray

'### Rahmenliste lschen
FF_SetControl "MFDL-Toolbox","Rahmennamen",""

'### Umlaute wieder zurck setzen
for n = 0 to Max
	pos = instr(NeuListenArray(n),TZ)
	if pos > 0 then
		NeuListenArray(n) = right(NeuListenArray(n),1) & mid(NeuListenArray(n),3,pos-3)
	end if

	'### ursprngliche Gro- und Kleinschreibung wieder herstellen
	for each element in UrListenArray
		if NeuListenArray(n) = ucase(element) then NeuListenArray(n) = element :   exit for
	next
	
	'### Neueintrag in Rahmenliste
	Rahmenarray = split(NeuListenArray(n),vbNewLine)
	FF_SetControl "MFDL-Toolbox","Rahmennamen",Rahmenarray(0)
next

End Sub
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+++ Rahmen in virtueller ListeAktuell sortieren Ende +++++++++++++++++++
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
